#include "cctk.h"
#include "CactusPUGH/PUGH/src/include/pugh.h"
#include "cctk_Arguments.h"

 /*@@
   @routine    BiBBAM_InitialWrapper
   @date       Mon Jun  8 12:57:20 1998
   @author     Gerd Lanfermann
   @desc 
        Bernd, if you like this, keep it. 
	(Yes. Included with minor changes. BB)
   
        This bib-bam interface solves that problem 
	that BAM_Initial_data, which is registered as 
	CACTUS_INITIAL* may only be called *once* by 
	the level0-Grid *after* all other boxes have been created
	by thorn_BoxInBox's SetupBoxInBox.c
	
	This wrapper is registered as CACTUS_INITIAL instead of BAM_Initial_Data.
	Since it will be called by each level, it returns until it has been 
	called by the highest box level	and then goes 
	ahead an calls BAM_Initial_Data with the base grid (level=0).
	
   @enddesc 
   @calls    BAM_Initial_Data(baseGH); GHbyLevel(0,0,0);
   @calledby   rfrTraverse
   @history 
 
   @endhistory 

@@*/
void BiBBAM_InitialWrapper(CCTK_ARGUMENTS) {

DECLARE_CCTK_ARGUMENTS

pGH *GH;
void BAM_Initial_Data(cGH *cctkGH, pGH *GH);

 GH = (pGH *) cctkGH->extensions [CCTK_GHExtensionHandle ("PUGH")];

#if 0
  if (CCTK_IsThornActive("BoxInBox")) {
    static int ll=0;
    pGH *baseGH;
    /* the following code was written for the original BoxInBox (not
       the PAGH version [dp]. */

  /* We are running with boxinbox */ 
  if (Contains("boxinbox","yes")) {

    /* find max level and save it*/
    if (ll==0) while (cctkGH = (pGH *) cctkGH->extensions [CCTK_GHExtensionHandle ("pugh")];
		      GHbyLevel(0,ll+1,0)) ll++;

    /* actually, the prelooprfr is handled incorrectly for box in box and 
       calls poststep routines that fail if we don't do something here, BB
    */
    setflat(GH);

    /* do not call initial data at this point since we are running with bib,
       but no boxes have been setup */
    if (ll==0) { 
      printf("%sBIBBAM FIRST CALL - RETURN%s \n",BOLDON,BOLDOFF); 
      return; 
    }
    
    printf("%sBIBBAM MaxLevel: %d current level %d %s\n",
	   BOLDON,ll,GH->level,BOLDOFF);    
    
    /* if this is called by the highest level box, we know that 
       all boxes have been set up properly and we can call 
       BAM_INITIAL for the base grid, which sweeps over all other boxes. */
    if (ll==GH->level)   {
      printf ("BIBBAM CALLING BAM_INITIAL \n");
      baseGH=GHbyLevel(0,0,0);
      BAM_Initial_Data(cctkGH,baseGH);
      return;
    }
    else 
      return;
  }
  }
#endif
  
  /* No thorn_BoxInbox compiled in or the boxinbox="no",
     then call BAM_INITIAL only for GH, which has level 0 */
  BAM_Initial_Data(cctkGH,GH);
}
