 /*@@
   @file      ParamCheck.F
   @date      Tues April 30 2002
   @author    Gabrielle Allen
   @desc 
   Check parameters for BAM capabilities
   @enddesc 
   @version $Header: /numrelcvs/AEIThorns/BAM_Elliptic/src/ParamCheck.c,v 1.1 2002/04/30 17:30:44 allen Exp $
 @@*/

#include "cctk.h"

#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

static const char *rcsid = "$Header: /numrelcvs/AEIThorns/BAM_Elliptic/src/ParamCheck.c,v 1.1 2002/04/30 17:30:44 allen Exp $";

CCTK_FILEVERSION(AEITHORNS_BAM_ELLIPTIC_ParamCheck_c)

/********************************************************************
 *********************     Local Data Types   ***********************
 ********************************************************************/

/********************************************************************
 ********************* Local Routine Prototypes *********************
 ********************************************************************/

/********************************************************************
 ***************** Scheduled Routine Prototypes *********************
 ********************************************************************/

void ParamCheck(CCTK_ARGUMENTS);

/********************************************************************
 ********************* Other Routine Prototypes *********************
 ********************************************************************/

/********************************************************************
 *********************     Local Data   *****************************
 ********************************************************************/

/********************************************************************
 *********************     External Routines   **********************
 ********************************************************************/

 /*@@
   @routine    ParamCheck
   @date       Tues April 30 2002
   @author     Gabrielle Allen
   @desc 
   Check parameters for BAM
   @enddesc 
   @calls     
@@*/
void BAM_Elliptic_ParamCheck(CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS

  /* Do we know how to deal with this type of metric ? */
  if(! CCTK_EQUALS(metric_type, "physical") &&
     ! CCTK_EQUALS(metric_type, "static conformal"))
  {
    CCTK_PARAMWARN("Unknown ADMBase::metric_type - known types are \"physical\" and \"static conformal\"");
  }

  if (CCTK_EQUALS(initial_data,"BrBr") ||
      CCTK_EQUALS(initial_data,"BrBr") ||
      CCTK_EQUALS(initial_data,"BrBr") ||
      CCTK_EQUALS(initial_data,"BrBr"))
  {
    if (!(CCTK_EQUALS(metric_type,"static conformal") &&
	  CCTK_EQUALS(conformal_storage, "factor+derivs+2nd derivs")))
    {
      CCTK_PARAMWARN("BAM initial data only for ADMBase::metric_type=\"static conformal\" and StaticConformal::conformal_storage=\"factor+derivs+2nd derivs\"");
    }
  }
      
  return;

}



/********************************************************************
 *********************     Local Routines   *************************
 ********************************************************************/

