 /*@@
   @file      Startup.c
   @date      Tue Jun 2 1999
   @author    Gabrielle Allen
   @desc 
   Startup and registration routines for BAM_Elliptic.
   @Enddesc 
 @@*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cctk.h"
#include "cctk_Parameters.h"

#include "CactusElliptic/EllBase/src/EllBase.h"
#include "CactusElliptic/EllBase/src/Ell_DBstructure.h"

void BAM_Register(cGH *GH) 
{

  DECLARE_CCTK_PARAMETERS 

  void BAM_Ell_LinConfMetricSolver(cGH *GH, 
				   int *MetricPsiI, 
				   int FieldI, 
				   int MI,
				   int NI, 
				   CCTK_REAL *AbsTol, 
				   CCTK_REAL *RelTol);
  void BAM_Ell_LinMetricSolver(cGH *GH, 
			       int *metric,
			       int field,
			       int MI, 
			       int NI, 
			       CCTK_REAL *AbsTol, 
			       CCTK_REAL *RelTol);

  int err;

  /* Register the solver with the elliptic classes */

  err = Ell_RegisterSolver(BAM_Ell_LinConfMetricSolver,"bam","Ell_LinConfMetric");
  if (!err==ELL_SUCCESS)
  {
    CCTK_WARN(0,"Failed to register bam for Ell_LinConfMetric");
  }
  err = Ell_RegisterSolver(BAM_Ell_LinMetricSolver,"bam","Ell_LinMetric");
  if (!err==ELL_SUCCESS)
  {
    CCTK_WARN(0,"Failed to register bam for Ell_LinMetric");
  }
}
