/* thorn_BAM_Elliptic: Multigrid Elliptic Solver for Cactus
   Copyright (C) 1998 Bernd Bruegmann 
*/
/* admcon.c */
/* Bernd Bruegmann, 10/97 */
/* Produced by Mathematica with diffadmcon.m */


#include "bbmg.h"
#define Power(x,y) (pow((double) (x), (double) (y)))
#define Log(x)     log((double) (x)))
#define pow2(x)    ((x)*(x))
#define pow2inv(x) (1.0/((x)*(x)))
#define Cal(x,y,z) ((x)?(y):(z))

void admcon(struct box *g, double *g11, double *g12, double *g13, double *g22, double *g23, double *g33, double *K11, double *K12, double *K13, double *K22, double *K23, double *K33, double *hamil, double *diffeo1, double *diffeo2, double *diffeo3)
{

/* only used for stand alone convergence testing in rare cases,
   so lets not worry about compiler warnings right now 
*/
#if 0

int i, j, k, ijk;
#if 0
int ii, jj, kk;
int m = g->m;
int n = g->n;
int o = g->o;
#endif
int di = g->di, dj = g->dj, dk = g->dk;
#if 0
double x0 = g->x;
double y0 = g->y;
double z0 = g->z;
#endif
double dx = g->d;
double oo2dx = 0.5/dx;
double oodx2 = 1.0/(dx*dx);
double oo4dx2 = oodx2/4.0;
double x, y, z;
#if 0
double xx, yy, zz;
#endif
double r, lr1, lr2, lr3;
#if 0
double psia[3][3][3];
#endif

double gginv11;
double gginv12;
double gginv13;
double gginv22;
double gginv23;
double gginv33;
double detg;
double ginv11;
double ginv12;
double ginv13;
double ginv22;
double ginv23;
double ginv33;
double KK11;
double KK12;
double KK13;
double KK22;
double KK23;
double KK33;
double trK;
double delg111;
double delg112;
double delg113;
double delg122;
double delg123;
double delg133;
double delg211;
double delg212;
double delg213;
double delg222;
double delg223;
double delg233;
double delg311;
double delg312;
double delg313;
double delg322;
double delg323;
double delg333;
double deldelg1111;
double deldelg1112;
double deldelg1113;
double deldelg1122;
double deldelg1123;
double deldelg1133;
double deldelg1211;
double deldelg1212;
double deldelg1213;
double deldelg1222;
double deldelg1223;
double deldelg1233;
double deldelg1311;
double deldelg1312;
double deldelg1313;
double deldelg1322;
double deldelg1323;
double deldelg1333;
double deldelg2211;
double deldelg2212;
double deldelg2213;
double deldelg2222;
double deldelg2223;
double deldelg2233;
double deldelg2311;
double deldelg2312;
double deldelg2313;
double deldelg2322;
double deldelg2323;
double deldelg2333;
double deldelg3311;
double deldelg3312;
double deldelg3313;
double deldelg3322;
double deldelg3323;
double deldelg3333;
double gammado111;
double gammado112;
double gammado113;
double gammado122;
double gammado123;
double gammado133;
double gammado211;
double gammado212;
double gammado213;
double gammado222;
double gammado223;
double gammado233;
double gammado311;
double gammado312;
double gammado313;
double gammado322;
double gammado323;
double gammado333;
double gamma111;
double gamma112;
double gamma113;
double gamma122;
double gamma123;
double gamma133;
double gamma211;
double gamma212;
double gamma213;
double gamma222;
double gamma223;
double gamma233;
double gamma311;
double gamma312;
double gamma313;
double gamma322;
double gamma323;
double gamma333;
double R11;
double R12;
double R13;
double R22;
double R23;
double R33;
double codelK111;
double codelK112;
double codelK113;
double codelK122;
double codelK123;
double codelK133;
double codelK211;
double codelK212;
double codelK213;
double codelK222;
double codelK223;
double codelK233;
double codelK311;
double codelK312;
double codelK313;
double codelK322;
double codelK323;
double codelK333;
double P11;
double P12;
double P13;
double P22;
double P23;
double P33;
double Q121;
double Q122;
double Q123;
double Q131;
double Q132;
double Q133;
double Q231;
double Q232;
double Q233;
#if 0
double pp001;
double pp010;
double pp011;
double pp012;
double pp021;
double pp100;
double pp101;
double pp102;
double pp110;
double pp111;
double pp112;
double pp120;
double pp121;
double pp122;
double pp201;
double pp210;
double pp211;
double pp212;
double pp221;
#endif



setrangePUGH(g, 1);
forrange(g) {{{
x = g->x + i*g->d;
y = g->y + j*g->d;
z = g->z + k*g->d;
r = sqrt(x*x + y*y + z*z);


if (dequal(r, 0.0)) r = dequaleps;
lr1 = x/r;
lr2 = y/r;
lr3 = z/r;



gginv11
=
g22[ijk]*g33[ijk] - pow2(g23[ijk])
;

gginv12
=
g13[ijk]*g23[ijk] - g12[ijk]*g33[ijk]
;

gginv13
=
-(g13[ijk]*g22[ijk]) + g12[ijk]*g23[ijk]
;

gginv22
=
g11[ijk]*g33[ijk] - pow2(g13[ijk])
;

gginv23
=
g12[ijk]*g13[ijk] - g11[ijk]*g23[ijk]
;

gginv33
=
g11[ijk]*g22[ijk] - pow2(g12[ijk])
;

detg
=
gginv11*g11[ijk] + gginv12*g12[ijk] + gginv13*g13[ijk]
;

if (detg < dequaleps) detg = dequaleps;
ginv11
=
gginv11/detg
;

ginv12
=
gginv12/detg
;

ginv13
=
gginv13/detg
;

ginv22
=
gginv22/detg
;

ginv23
=
gginv23/detg
;

ginv33
=
gginv33/detg
;

KK11
=
K11[ijk]*(ginv11*K11[ijk] + ginv12*K12[ijk] + ginv13*K13[ijk]) + 
   K12[ijk]*(ginv12*K11[ijk] + ginv22*K12[ijk] + ginv23*K13[ijk]) + 
   K13[ijk]*(ginv13*K11[ijk] + ginv23*K12[ijk] + ginv33*K13[ijk])
;

KK12
=
K12[ijk]*(ginv11*K11[ijk] + ginv12*K12[ijk] + ginv13*K13[ijk]) + 
   (ginv12*K11[ijk] + ginv22*K12[ijk] + ginv23*K13[ijk])*K22[ijk] + 
   (ginv13*K11[ijk] + ginv23*K12[ijk] + ginv33*K13[ijk])*K23[ijk]
;

KK12
=
K11[ijk]*(ginv11*K12[ijk] + ginv12*K22[ijk] + ginv13*K23[ijk]) + 
   K12[ijk]*(ginv12*K12[ijk] + ginv22*K22[ijk] + ginv23*K23[ijk]) + 
   K13[ijk]*(ginv13*K12[ijk] + ginv23*K22[ijk] + ginv33*K23[ijk])
;

KK13
=
K13[ijk]*(ginv11*K11[ijk] + ginv12*K12[ijk] + ginv13*K13[ijk]) + 
   (ginv12*K11[ijk] + ginv22*K12[ijk] + ginv23*K13[ijk])*K23[ijk] + 
   (ginv13*K11[ijk] + ginv23*K12[ijk] + ginv33*K13[ijk])*K33[ijk]
;

KK13
=
K11[ijk]*(ginv11*K13[ijk] + ginv12*K23[ijk] + ginv13*K33[ijk]) + 
   K12[ijk]*(ginv12*K13[ijk] + ginv22*K23[ijk] + ginv23*K33[ijk]) + 
   K13[ijk]*(ginv13*K13[ijk] + ginv23*K23[ijk] + ginv33*K33[ijk])
;

KK22
=
K12[ijk]*(ginv11*K12[ijk] + ginv12*K22[ijk] + ginv13*K23[ijk]) + 
   K22[ijk]*(ginv12*K12[ijk] + ginv22*K22[ijk] + ginv23*K23[ijk]) + 
   K23[ijk]*(ginv13*K12[ijk] + ginv23*K22[ijk] + ginv33*K23[ijk])
;

KK23
=
K13[ijk]*(ginv11*K12[ijk] + ginv12*K22[ijk] + ginv13*K23[ijk]) + 
   K23[ijk]*(ginv12*K12[ijk] + ginv22*K22[ijk] + ginv23*K23[ijk]) + 
   (ginv13*K12[ijk] + ginv23*K22[ijk] + ginv33*K23[ijk])*K33[ijk]
;

KK23
=
K12[ijk]*(ginv11*K13[ijk] + ginv12*K23[ijk] + ginv13*K33[ijk]) + 
   K22[ijk]*(ginv12*K13[ijk] + ginv22*K23[ijk] + ginv23*K33[ijk]) + 
   K23[ijk]*(ginv13*K13[ijk] + ginv23*K23[ijk] + ginv33*K33[ijk])
;

KK33
=
K13[ijk]*(ginv11*K13[ijk] + ginv12*K23[ijk] + ginv13*K33[ijk]) + 
   K23[ijk]*(ginv12*K13[ijk] + ginv22*K23[ijk] + ginv23*K33[ijk]) + 
   K33[ijk]*(ginv13*K13[ijk] + ginv23*K23[ijk] + ginv33*K33[ijk])
;

trK
=
ginv11*K11[ijk] + 2*ginv12*K12[ijk] + 2*ginv13*K13[ijk] + ginv22*K22[ijk] + 
   2*ginv23*K23[ijk] + ginv33*K33[ijk]
;

delg111
=
oo2dx*(-g11[-di + ijk] + g11[di + ijk])
;

delg112
=
oo2dx*(-g12[-di + ijk] + g12[di + ijk])
;

delg113
=
oo2dx*(-g13[-di + ijk] + g13[di + ijk])
;

delg122
=
oo2dx*(-g22[-di + ijk] + g22[di + ijk])
;

delg123
=
oo2dx*(-g23[-di + ijk] + g23[di + ijk])
;

delg133
=
oo2dx*(-g33[-di + ijk] + g33[di + ijk])
;

delg211
=
oo2dx*(-g11[-dj + ijk] + g11[dj + ijk])
;

delg212
=
oo2dx*(-g12[-dj + ijk] + g12[dj + ijk])
;

delg213
=
oo2dx*(-g13[-dj + ijk] + g13[dj + ijk])
;

delg222
=
oo2dx*(-g22[-dj + ijk] + g22[dj + ijk])
;

delg223
=
oo2dx*(-g23[-dj + ijk] + g23[dj + ijk])
;

delg233
=
oo2dx*(-g33[-dj + ijk] + g33[dj + ijk])
;

delg311
=
oo2dx*(-g11[-dk + ijk] + g11[dk + ijk])
;

delg312
=
oo2dx*(-g12[-dk + ijk] + g12[dk + ijk])
;

delg313
=
oo2dx*(-g13[-dk + ijk] + g13[dk + ijk])
;

delg322
=
oo2dx*(-g22[-dk + ijk] + g22[dk + ijk])
;

delg323
=
oo2dx*(-g23[-dk + ijk] + g23[dk + ijk])
;

delg333
=
oo2dx*(-g33[-dk + ijk] + g33[dk + ijk])
;

deldelg1111
=
oodx2*(-2*g11[ijk] + g11[-di + ijk] + g11[di + ijk])
;

deldelg1112
=
oodx2*(-2*g12[ijk] + g12[-di + ijk] + g12[di + ijk])
;

deldelg1113
=
oodx2*(-2*g13[ijk] + g13[-di + ijk] + g13[di + ijk])
;

deldelg1122
=
oodx2*(-2*g22[ijk] + g22[-di + ijk] + g22[di + ijk])
;

deldelg1123
=
oodx2*(-2*g23[ijk] + g23[-di + ijk] + g23[di + ijk])
;

deldelg1133
=
oodx2*(-2*g33[ijk] + g33[-di + ijk] + g33[di + ijk])
;

deldelg1211
=
oo4dx2*(g11[-di - dj + ijk] - g11[di - dj + ijk] - g11[-di + dj + ijk] + 
     g11[di + dj + ijk])
;

deldelg1212
=
oo4dx2*(g12[-di - dj + ijk] - g12[di - dj + ijk] - g12[-di + dj + ijk] + 
     g12[di + dj + ijk])
;

deldelg1213
=
oo4dx2*(g13[-di - dj + ijk] - g13[di - dj + ijk] - g13[-di + dj + ijk] + 
     g13[di + dj + ijk])
;

deldelg1222
=
oo4dx2*(g22[-di - dj + ijk] - g22[di - dj + ijk] - g22[-di + dj + ijk] + 
     g22[di + dj + ijk])
;

deldelg1223
=
oo4dx2*(g23[-di - dj + ijk] - g23[di - dj + ijk] - g23[-di + dj + ijk] + 
     g23[di + dj + ijk])
;

deldelg1233
=
oo4dx2*(g33[-di - dj + ijk] - g33[di - dj + ijk] - g33[-di + dj + ijk] + 
     g33[di + dj + ijk])
;

deldelg1311
=
oo4dx2*(g11[-di - dk + ijk] - g11[di - dk + ijk] - g11[-di + dk + ijk] + 
     g11[di + dk + ijk])
;

deldelg1312
=
oo4dx2*(g12[-di - dk + ijk] - g12[di - dk + ijk] - g12[-di + dk + ijk] + 
     g12[di + dk + ijk])
;

deldelg1313
=
oo4dx2*(g13[-di - dk + ijk] - g13[di - dk + ijk] - g13[-di + dk + ijk] + 
     g13[di + dk + ijk])
;

deldelg1322
=
oo4dx2*(g22[-di - dk + ijk] - g22[di - dk + ijk] - g22[-di + dk + ijk] + 
     g22[di + dk + ijk])
;

deldelg1323
=
oo4dx2*(g23[-di - dk + ijk] - g23[di - dk + ijk] - g23[-di + dk + ijk] + 
     g23[di + dk + ijk])
;

deldelg1333
=
oo4dx2*(g33[-di - dk + ijk] - g33[di - dk + ijk] - g33[-di + dk + ijk] + 
     g33[di + dk + ijk])
;

deldelg2211
=
oodx2*(-2*g11[ijk] + g11[-dj + ijk] + g11[dj + ijk])
;

deldelg2212
=
oodx2*(-2*g12[ijk] + g12[-dj + ijk] + g12[dj + ijk])
;

deldelg2213
=
oodx2*(-2*g13[ijk] + g13[-dj + ijk] + g13[dj + ijk])
;

deldelg2222
=
oodx2*(-2*g22[ijk] + g22[-dj + ijk] + g22[dj + ijk])
;

deldelg2223
=
oodx2*(-2*g23[ijk] + g23[-dj + ijk] + g23[dj + ijk])
;

deldelg2233
=
oodx2*(-2*g33[ijk] + g33[-dj + ijk] + g33[dj + ijk])
;

deldelg2311
=
oo4dx2*(g11[-dj - dk + ijk] - g11[dj - dk + ijk] - g11[-dj + dk + ijk] + 
     g11[dj + dk + ijk])
;

deldelg2312
=
oo4dx2*(g12[-dj - dk + ijk] - g12[dj - dk + ijk] - g12[-dj + dk + ijk] + 
     g12[dj + dk + ijk])
;

deldelg2313
=
oo4dx2*(g13[-dj - dk + ijk] - g13[dj - dk + ijk] - g13[-dj + dk + ijk] + 
     g13[dj + dk + ijk])
;

deldelg2322
=
oo4dx2*(g22[-dj - dk + ijk] - g22[dj - dk + ijk] - g22[-dj + dk + ijk] + 
     g22[dj + dk + ijk])
;

deldelg2323
=
oo4dx2*(g23[-dj - dk + ijk] - g23[dj - dk + ijk] - g23[-dj + dk + ijk] + 
     g23[dj + dk + ijk])
;

deldelg2333
=
oo4dx2*(g33[-dj - dk + ijk] - g33[dj - dk + ijk] - g33[-dj + dk + ijk] + 
     g33[dj + dk + ijk])
;

deldelg3311
=
oodx2*(-2*g11[ijk] + g11[-dk + ijk] + g11[dk + ijk])
;

deldelg3312
=
oodx2*(-2*g12[ijk] + g12[-dk + ijk] + g12[dk + ijk])
;

deldelg3313
=
oodx2*(-2*g13[ijk] + g13[-dk + ijk] + g13[dk + ijk])
;

deldelg3322
=
oodx2*(-2*g22[ijk] + g22[-dk + ijk] + g22[dk + ijk])
;

deldelg3323
=
oodx2*(-2*g23[ijk] + g23[-dk + ijk] + g23[dk + ijk])
;

deldelg3333
=
oodx2*(-2*g33[ijk] + g33[-dk + ijk] + g33[dk + ijk])
;

gammado111
=
delg111/2.
;

gammado112
=
delg211/2.
;

gammado113
=
delg311/2.
;

gammado122
=
-delg122/2. + delg212
;

gammado123
=
-delg123/2. + delg213/2. + delg312/2.
;

gammado133
=
-delg133/2. + delg313
;

gammado211
=
delg112 - delg211/2.
;

gammado212
=
delg122/2.
;

gammado213
=
delg123/2. - delg213/2. + delg312/2.
;

gammado222
=
delg222/2.
;

gammado223
=
delg322/2.
;

gammado233
=
-delg233/2. + delg323
;

gammado311
=
delg113 - delg311/2.
;

gammado312
=
delg123/2. + delg213/2. - delg312/2.
;

gammado313
=
delg133/2.
;

gammado322
=
delg223 - delg322/2.
;

gammado323
=
delg233/2.
;

gammado333
=
delg333/2.
;

gamma111
=
gammado111*ginv11 + gammado211*ginv12 + gammado311*ginv13
;

gamma112
=
gammado112*ginv11 + gammado212*ginv12 + gammado312*ginv13
;

gamma113
=
gammado113*ginv11 + gammado213*ginv12 + gammado313*ginv13
;

gamma122
=
gammado122*ginv11 + gammado222*ginv12 + gammado322*ginv13
;

gamma123
=
gammado123*ginv11 + gammado223*ginv12 + gammado323*ginv13
;

gamma133
=
gammado133*ginv11 + gammado233*ginv12 + gammado333*ginv13
;

gamma211
=
gammado111*ginv12 + gammado211*ginv22 + gammado311*ginv23
;

gamma212
=
gammado112*ginv12 + gammado212*ginv22 + gammado312*ginv23
;

gamma213
=
gammado113*ginv12 + gammado213*ginv22 + gammado313*ginv23
;

gamma222
=
gammado122*ginv12 + gammado222*ginv22 + gammado322*ginv23
;

gamma223
=
gammado123*ginv12 + gammado223*ginv22 + gammado323*ginv23
;

gamma233
=
gammado133*ginv12 + gammado233*ginv22 + gammado333*ginv23
;

gamma311
=
gammado111*ginv13 + gammado211*ginv23 + gammado311*ginv33
;

gamma312
=
gammado112*ginv13 + gammado212*ginv23 + gammado312*ginv33
;

gamma313
=
gammado113*ginv13 + gammado213*ginv23 + gammado313*ginv33
;

gamma322
=
gammado122*ginv13 + gammado222*ginv23 + gammado322*ginv33
;

gamma323
=
gammado123*ginv13 + gammado223*ginv23 + gammado323*ginv33
;

gamma333
=
gammado133*ginv13 + gammado233*ginv23 + gammado333*ginv33
;

R11
=
(-deldelg1122/2. + deldelg1212 - deldelg2211/2. + gamma112*gammado112 - 
      gamma111*gammado122 + gamma212*gammado212 - gamma211*gammado222 + 
      gamma312*gammado312 - gamma311*gammado322)*ginv22 + 
   (-deldelg1123 + deldelg1213 + deldelg1312 - deldelg2311 + 
      2*gamma112*gammado113 - 2*gamma111*gammado123 + 2*gamma212*gammado213 - 
      2*gamma211*gammado223 + 2*gamma312*gammado313 - 2*gamma311*gammado323)*
    ginv23 + (-deldelg1133/2. + deldelg1313 - deldelg3311/2. + 
      gamma113*gammado113 - gamma111*gammado133 + gamma213*gammado213 - 
      gamma211*gammado233 + gamma313*gammado313 - gamma311*gammado333)*ginv33
;

R12
=
(deldelg1122/2. - deldelg1212 + deldelg2211/2. - gamma112*gammado112 + 
      gamma111*gammado122 - gamma212*gammado212 + gamma211*gammado222 - 
      gamma312*gammado312 + gamma311*gammado322)*ginv12 + 
   (deldelg1123/2. - deldelg1213/2. - deldelg1312/2. + deldelg2311/2. - 
      gamma112*gammado113 + gamma111*gammado123 - gamma212*gammado213 + 
      gamma211*gammado223 - gamma312*gammado313 + gamma311*gammado323)*ginv13\
    + (-deldelg1223/2. + deldelg1322/2. + deldelg2213/2. - deldelg2312/2. + 
      gamma113*gammado122 - gamma112*gammado123 + gamma213*gammado222 - 
      gamma212*gammado223 + gamma313*gammado322 - gamma312*gammado323)*ginv23\
    + (-deldelg1233/2. + deldelg1323/2. + deldelg2313/2. - deldelg3312/2. + 
      gamma113*gammado123 - gamma112*gammado133 + gamma213*gammado223 - 
      gamma212*gammado233 + gamma313*gammado323 - gamma312*gammado333)*ginv33
;

R13
=
(deldelg1123/2. - deldelg1213/2. - deldelg1312/2. + deldelg2311/2. - 
      gamma112*gammado113 + gamma111*gammado123 - gamma212*gammado213 + 
      gamma211*gammado223 - gamma312*gammado313 + gamma311*gammado323)*ginv12\
    + (deldelg1133/2. - deldelg1313 + deldelg3311/2. - gamma113*gammado113 + 
      gamma111*gammado133 - gamma213*gammado213 + gamma211*gammado233 - 
      gamma313*gammado313 + gamma311*gammado333)*ginv13 + 
   (deldelg1223/2. - deldelg1322/2. - deldelg2213/2. + deldelg2312/2. - 
      gamma113*gammado122 + gamma112*gammado123 - gamma213*gammado222 + 
      gamma212*gammado223 - gamma313*gammado322 + gamma312*gammado323)*ginv22\
    + (deldelg1233/2. - deldelg1323/2. - deldelg2313/2. + deldelg3312/2. - 
      gamma113*gammado123 + gamma112*gammado133 - gamma213*gammado223 + 
      gamma212*gammado233 - gamma313*gammado323 + gamma312*gammado333)*ginv23
;

R22
=
(-deldelg1122/2. + deldelg1212 - deldelg2211/2. + gamma112*gammado112 - 
      gamma111*gammado122 + gamma212*gammado212 - gamma211*gammado222 + 
      gamma312*gammado312 - gamma311*gammado322)*ginv11 + 
   (deldelg1223 - deldelg1322 - deldelg2213 + deldelg2312 - 
      2*gamma113*gammado122 + 2*gamma112*gammado123 - 2*gamma213*gammado222 + 
      2*gamma212*gammado223 - 2*gamma313*gammado322 + 2*gamma312*gammado323)*
    ginv13 + (-deldelg2233/2. + deldelg2323 - deldelg3322/2. + 
      gamma123*gammado123 - gamma122*gammado133 + gamma223*gammado223 - 
      gamma222*gammado233 + gamma323*gammado323 - gamma322*gammado333)*ginv33
;

R23
=
(-deldelg1123/2. + deldelg1213/2. + deldelg1312/2. - deldelg2311/2. + 
      gamma112*gammado113 - gamma111*gammado123 + gamma212*gammado213 - 
      gamma211*gammado223 + gamma312*gammado313 - gamma311*gammado323)*ginv11\
    + (-deldelg1223/2. + deldelg1322/2. + deldelg2213/2. - deldelg2312/2. + 
      gamma113*gammado122 - gamma112*gammado123 + gamma213*gammado222 - 
      gamma212*gammado223 + gamma313*gammado322 - gamma312*gammado323)*ginv12\
    + (deldelg1233/2. - deldelg1323/2. - deldelg2313/2. + deldelg3312/2. - 
      gamma113*gammado123 + gamma112*gammado133 - gamma213*gammado223 + 
      gamma212*gammado233 - gamma313*gammado323 + gamma312*gammado333)*ginv13\
    + (deldelg2233/2. - deldelg2323 + deldelg3322/2. - gamma123*gammado123 + 
      gamma122*gammado133 - gamma223*gammado223 + gamma222*gammado233 - 
      gamma323*gammado323 + gamma322*gammado333)*ginv23
;

R33
=
(-deldelg1133/2. + deldelg1313 - deldelg3311/2. + gamma113*gammado113 - 
      gamma111*gammado133 + gamma213*gammado213 - gamma211*gammado233 + 
      gamma313*gammado313 - gamma311*gammado333)*ginv11 + 
   (-deldelg1233 + deldelg1323 + deldelg2313 - deldelg3312 + 
      2*gamma113*gammado123 - 2*gamma112*gammado133 + 2*gamma213*gammado223 - 
      2*gamma212*gammado233 + 2*gamma313*gammado323 - 2*gamma312*gammado333)*
    ginv12 + (-deldelg2233/2. + deldelg2323 - deldelg3322/2. + 
      gamma123*gammado123 - gamma122*gammado133 + gamma223*gammado223 - 
      gamma222*gammado233 + gamma323*gammado323 - gamma322*gammado333)*ginv22
;

codelK111
=
-2*gamma111*K11[ijk] + oo2dx*(-K11[-di + ijk] + K11[di + ijk]) - 
   2*gamma211*K12[ijk] - 2*gamma311*K13[ijk]
;

codelK112
=
-(gamma112*K11[ijk]) - gamma111*K12[ijk] - gamma212*K12[ijk] + 
   oo2dx*(-K12[-di + ijk] + K12[di + ijk]) - gamma312*K13[ijk] - 
   gamma211*K22[ijk] - gamma311*K23[ijk]
;

codelK113
=
-(gamma113*K11[ijk]) - gamma213*K12[ijk] - gamma111*K13[ijk] - 
   gamma313*K13[ijk] + oo2dx*(-K13[-di + ijk] + K13[di + ijk]) - 
   gamma211*K23[ijk] - gamma311*K33[ijk]
;

codelK122
=
-2*gamma112*K12[ijk] - 2*gamma212*K22[ijk] + 
   oo2dx*(-K22[-di + ijk] + K22[di + ijk]) - 2*gamma312*K23[ijk]
;

codelK123
=
-(gamma113*K12[ijk]) - gamma112*K13[ijk] - gamma213*K22[ijk] - 
   gamma212*K23[ijk] - gamma313*K23[ijk] + 
   oo2dx*(-K23[-di + ijk] + K23[di + ijk]) - gamma312*K33[ijk]
;

codelK133
=
-2*gamma113*K13[ijk] - 2*gamma213*K23[ijk] - 2*gamma313*K33[ijk] + 
   oo2dx*(-K33[-di + ijk] + K33[di + ijk])
;

codelK211
=
-2*gamma112*K11[ijk] + oo2dx*(-K11[-dj + ijk] + K11[dj + ijk]) - 
   2*gamma212*K12[ijk] - 2*gamma312*K13[ijk]
;

codelK212
=
-(gamma122*K11[ijk]) - gamma112*K12[ijk] - gamma222*K12[ijk] + 
   oo2dx*(-K12[-dj + ijk] + K12[dj + ijk]) - gamma322*K13[ijk] - 
   gamma212*K22[ijk] - gamma312*K23[ijk]
;

codelK213
=
-(gamma123*K11[ijk]) - gamma223*K12[ijk] - gamma112*K13[ijk] - 
   gamma323*K13[ijk] + oo2dx*(-K13[-dj + ijk] + K13[dj + ijk]) - 
   gamma212*K23[ijk] - gamma312*K33[ijk]
;

codelK222
=
-2*gamma122*K12[ijk] - 2*gamma222*K22[ijk] + 
   oo2dx*(-K22[-dj + ijk] + K22[dj + ijk]) - 2*gamma322*K23[ijk]
;

codelK223
=
-(gamma123*K12[ijk]) - gamma122*K13[ijk] - gamma223*K22[ijk] - 
   gamma222*K23[ijk] - gamma323*K23[ijk] + 
   oo2dx*(-K23[-dj + ijk] + K23[dj + ijk]) - gamma322*K33[ijk]
;

codelK233
=
-2*gamma123*K13[ijk] - 2*gamma223*K23[ijk] - 2*gamma323*K33[ijk] + 
   oo2dx*(-K33[-dj + ijk] + K33[dj + ijk])
;

codelK311
=
-2*gamma113*K11[ijk] + oo2dx*(-K11[-dk + ijk] + K11[dk + ijk]) - 
   2*gamma213*K12[ijk] - 2*gamma313*K13[ijk]
;

codelK312
=
-(gamma123*K11[ijk]) - gamma113*K12[ijk] - gamma223*K12[ijk] + 
   oo2dx*(-K12[-dk + ijk] + K12[dk + ijk]) - gamma323*K13[ijk] - 
   gamma213*K22[ijk] - gamma313*K23[ijk]
;

codelK313
=
-(gamma133*K11[ijk]) - gamma233*K12[ijk] - gamma113*K13[ijk] - 
   gamma333*K13[ijk] + oo2dx*(-K13[-dk + ijk] + K13[dk + ijk]) - 
   gamma213*K23[ijk] - gamma313*K33[ijk]
;

codelK322
=
-2*gamma123*K12[ijk] - 2*gamma223*K22[ijk] + 
   oo2dx*(-K22[-dk + ijk] + K22[dk + ijk]) - 2*gamma323*K23[ijk]
;

codelK323
=
-(gamma133*K12[ijk]) - gamma123*K13[ijk] - gamma233*K22[ijk] - 
   gamma223*K23[ijk] - gamma333*K23[ijk] + 
   oo2dx*(-K23[-dk + ijk] + K23[dk + ijk]) - gamma323*K33[ijk]
;

codelK333
=
-2*gamma133*K13[ijk] - 2*gamma233*K23[ijk] - 2*gamma333*K33[ijk] + 
   oo2dx*(-K33[-dk + ijk] + K33[dk + ijk])
;

P11
=
-KK11 + R11 + trK*K11[ijk]
;

P12
=
-KK12 + R12 + trK*K12[ijk]
;

P13
=
-KK13 + R13 + trK*K13[ijk]
;

P22
=
-KK22 + R22 + trK*K22[ijk]
;

P23
=
-KK23 + R23 + trK*K23[ijk]
;

P33
=
-KK33 + R33 + trK*K33[ijk]
;

Q121
=
-codelK112 + codelK211
;

Q122
=
-codelK122 + codelK212
;

Q123
=
-codelK123 + codelK213
;

Q131
=
-codelK113 + codelK311
;

Q132
=
-codelK123 + codelK312
;

Q133
=
-codelK133 + codelK313
;

Q231
=
-codelK213 + codelK312
;

Q232
=
-codelK223 + codelK322
;

Q233
=
-codelK233 + codelK323
;

hamil[ijk]
=
ginv11*P11 + 2*ginv12*P12 + 2*ginv13*P13 + ginv22*P22 + 2*ginv23*P23 + 
   ginv33*P33
;

diffeo1[ijk]
=
ginv12*Q121 + ginv22*Q122 + ginv23*Q123 + ginv13*Q131 + ginv23*Q132 + 
   ginv33*Q133
;

diffeo2[ijk]
=
-(ginv11*Q121) - ginv12*Q122 - ginv13*Q123 + ginv13*Q231 + ginv23*Q232 + 
   ginv33*Q233
;

diffeo3[ijk]
=
-(ginv11*Q131) - ginv12*Q132 - ginv13*Q133 - ginv12*Q231 - ginv22*Q232 - 
   ginv23*Q233
;



}}}  /* loop k, j, i */

#endif
} /* return from admcon() */

/* admcon.c */
/* nmul = 416,  ndiv = 100,  nsum = 992, nfields = 16 */
