/* thorn_BAM_Elliptic: Multigrid Elliptic Solver for Cactus
   Copyright (C) 1998 Bernd Bruegmann 
*/
/* fortran.c */
/* Bernd Bruegmann, 10/97 */

/* this seems to be the standard way to call FORTRAN from C in Cactus */

#include <stdio.h>

#include "CactusPUGH/PUGH/src/include/pugh.h"

/* Joan and Toni again */
#ifdef THORN_STANDARDEINSTEIN
#define flat FORTRAN_NAME(flat_, FLAT, flat)
void FMODIFIER  flat(CREATE_STANDARDEINSTEIN_PROTO);
#endif

#define set_laplace_bmcactus_f FORTRAN_NAME(set_laplace_bmcactus_f)

#ifdef THORN_BMUTIL
#define metricderiv FORTRAN_NAME(metricderiv_, METRICDERIV, metricderiv)
#define vectorini FORTRAN_NAME(vectorini_, VECTORINI, vectorini)

void FMODIFIER  metricderiv(CREATE_METRICDERIVVARS_PROTO);
void FMODIFIER  vectorini(CREATE_VECTORINIVARS_PROTO);

#endif 



/* call standard cactus routine to initialize for Minkowski space
   called no matter what the model is to make sure we always get a valid model
   cactus should do that itself
*/
/*
void setflat(pGH *GH)
{
#ifdef THORN_STANDARDEINSTEIN
  SetupFortranArrays(GH);
  flat(CREATE_STANDARDEINSTEIN_ARGS(GH));
#else
  printf(
    "BAM WARNING: setflat() calls but thorn_StandardEinstein is missing\n");
#endif
}
*/



/* set up for Bona-Masso: derivs of metric and the Vs */
void setBM(pGH *GH)
{
#ifdef THORN_BMUTIL
  SetupFortranArrays(GH);
  metricderiv(CREATE_METRICDERIVVARS_ARGS(GH));
  SyncGH(GH);
  vectorini(CREATE_VECTORINIVARS_ARGS(GH));
  SyncGH(GH);
#else
  if (0) printf("BAM WARNING: setBM() calls but thorn_BMUtil is missing\n");
#endif
}




/* set coefficients for Laplacian */
void set_laplace_BMcactus(pGH *GH)
{
#ifdef FIXME 
  set_laplace_bmcactus_f(CREATE_BAM_ELLIPTIC_ARGS(GH));
#endif
}





/* the cactus onebound routine */
void setob(pGH *GH, int n, double symx, double symy, double symz)
{
#ifdef THORN_STANDARDEINSTEIN
#define onebound FORTRAN_NAME(onebound_, ONEBOUND, onebound)
  onebound(CREATE_ARENAVARS_ARGS(GH), 
	   GH->gridFuncs[n]->data, 
	   &symx, &symy, &symz);
#endif 
}




