/* bamminshiftsource.c */
/* Bernd Bruegmann, 15.12.1999 */
/* Produced with Mathematica */

#include "bamveclap.h"
extern int minstrain, mindistortion, bctgauge, confharmonic;

#define Power(x,y) (pow((double) (x), (double) (y)))
#define Log(x)     log((double) (x)))
#define pow2(x)    ((x)*(x))
#define pow2inv(x) (1.0/((x)*(x)))

#define Cal(x,y,z) ((x)?(y):(z))





void bamminshiftsource(CCTK_ARGUMENTS) {

DECLARE_CCTK_ARGUMENTS
int nocd = (*conformal_state == 0);
int i, j, k, di, dj, dk, ijk;
double dx = cctkGH->cctk_delta_space[0];
double dy = cctkGH->cctk_delta_space[1];
double dz = cctkGH->cctk_delta_space[2];
double oo2dx = 1/(2*dx), oo2dy = 1/(2*dy), oo2dz = 1/(2*dz);
double oodx2 = 1/(dx*dx), oody2 = 1/(dy*dy), oodz2 = 1/(dz*dz);
double oo4dxdy = 1/(4*dx*dy);
double oo4dxdz = 1/(4*dx*dz);
double oo4dydz = 1/(4*dy*dz);

double Cif;
double f;
double fdetg;
double B1111;
double B1112;
double B1113;
double B1122;
double B1123;
double B1133;
double B1212;
double B1213;
double B1222;
double B1223;
double B1233;
double B1313;
double B1322;
double B1323;
double B1333;
double B2222;
double B2223;
double B2233;
double B2323;
double B2333;
double B3333;
double codelalphaK111;
double codelalphaK112;
double codelalphaK113;
double codelalphaK122;
double codelalphaK123;
double codelalphaK133;
double codelalphaK211;
double codelalphaK212;
double codelalphaK213;
double codelalphaK222;
double codelalphaK223;
double codelalphaK233;
double codelalphaK311;
double codelalphaK312;
double codelalphaK313;
double codelalphaK322;
double codelalphaK323;
double codelalphaK333;
double codelK111;
double codelK112;
double codelK113;
double codelK122;
double codelK123;
double codelK133;
double codelK211;
double codelK212;
double codelK213;
double codelK222;
double codelK223;
double codelK233;
double codelK311;
double codelK312;
double codelK313;
double codelK322;
double codelK323;
double codelK333;
double delg111;
double delg112;
double delg113;
double delg122;
double delg123;
double delg133;
double delg211;
double delg212;
double delg213;
double delg222;
double delg223;
double delg233;
double delg311;
double delg312;
double delg313;
double delg322;
double delg323;
double delg333;
double delgb111;
double delgb112;
double delgb113;
double delgb122;
double delgb123;
double delgb133;
double delgb211;
double delgb212;
double delgb213;
double delgb222;
double delgb223;
double delgb233;
double delgb311;
double delgb312;
double delgb313;
double delgb322;
double delgb323;
double delgb333;
double df1;
double df2;
double df3;
double gamma111;
double gamma112;
double gamma113;
double gamma122;
double gamma123;
double gamma133;
double gamma211;
double gamma212;
double gamma213;
double gamma222;
double gamma223;
double gamma233;
double gamma311;
double gamma312;
double gamma313;
double gamma322;
double gamma323;
double gamma333;
double gammado111;
double gammado112;
double gammado113;
double gammado122;
double gammado123;
double gammado133;
double gammado211;
double gammado212;
double gammado213;
double gammado222;
double gammado223;
double gammado233;
double gammado311;
double gammado312;
double gammado313;
double gammado322;
double gammado323;
double gammado333;
double gginv11;
double gginv12;
double gginv13;
double gginv22;
double gginv23;
double gginv33;
double ginv11;
double ginv12;
double ginv13;
double ginv22;
double ginv23;
double ginv33;



#define vlN1 vl_N1
#define vlN2 vl_N2
#define vlN3 vl_N3

forinnerpoints(cctkGH) {


f
=
Cal(nocd,1,Power(psi[ijk],4))
;

df1
=
Cal(nocd,0,4*f*psix[ijk])
;

df2
=
Cal(nocd,0,4*f*psiy[ijk])
;

df3
=
Cal(nocd,0,4*f*psiz[ijk])
;

gginv11
=
gyy[ijk]*gzz[ijk] - pow2(gyz[ijk])
;

gginv12
=
gxz[ijk]*gyz[ijk] - gxy[ijk]*gzz[ijk]
;

gginv13
=
-(gxz[ijk]*gyy[ijk]) + gxy[ijk]*gyz[ijk]
;

gginv22
=
gxx[ijk]*gzz[ijk] - pow2(gxz[ijk])
;

gginv23
=
gxy[ijk]*gxz[ijk] - gxx[ijk]*gyz[ijk]
;

gginv33
=
gxx[ijk]*gyy[ijk] - pow2(gxy[ijk])
;

fdetg
=
f*(gginv11*gxx[ijk] + gginv12*gxy[ijk] + gginv13*gxz[ijk])
;

ginv11
=
gginv11/fdetg
;

ginv12
=
gginv12/fdetg
;

ginv13
=
gginv13/fdetg
;

ginv22
=
gginv22/fdetg
;

ginv23
=
gginv23/fdetg
;

ginv33
=
gginv33/fdetg
;

delgb111
=
oo2dx*(-gxx[-di + ijk] + gxx[di + ijk])
;

delgb112
=
oo2dx*(-gxy[-di + ijk] + gxy[di + ijk])
;

delgb113
=
oo2dx*(-gxz[-di + ijk] + gxz[di + ijk])
;

delgb122
=
oo2dx*(-gyy[-di + ijk] + gyy[di + ijk])
;

delgb123
=
oo2dx*(-gyz[-di + ijk] + gyz[di + ijk])
;

delgb133
=
oo2dx*(-gzz[-di + ijk] + gzz[di + ijk])
;

delgb211
=
oo2dy*(-gxx[-dj + ijk] + gxx[dj + ijk])
;

delgb212
=
oo2dy*(-gxy[-dj + ijk] + gxy[dj + ijk])
;

delgb213
=
oo2dy*(-gxz[-dj + ijk] + gxz[dj + ijk])
;

delgb222
=
oo2dy*(-gyy[-dj + ijk] + gyy[dj + ijk])
;

delgb223
=
oo2dy*(-gyz[-dj + ijk] + gyz[dj + ijk])
;

delgb233
=
oo2dy*(-gzz[-dj + ijk] + gzz[dj + ijk])
;

delgb311
=
oo2dz*(-gxx[-dk + ijk] + gxx[dk + ijk])
;

delgb312
=
oo2dz*(-gxy[-dk + ijk] + gxy[dk + ijk])
;

delgb313
=
oo2dz*(-gxz[-dk + ijk] + gxz[dk + ijk])
;

delgb322
=
oo2dz*(-gyy[-dk + ijk] + gyy[dk + ijk])
;

delgb323
=
oo2dz*(-gyz[-dk + ijk] + gyz[dk + ijk])
;

delgb333
=
oo2dz*(-gzz[-dk + ijk] + gzz[dk + ijk])
;

delg111
=
delgb111*f + df1*gxx[ijk]
;

delg112
=
delgb112*f + df1*gxy[ijk]
;

delg113
=
delgb113*f + df1*gxz[ijk]
;

delg122
=
delgb122*f + df1*gyy[ijk]
;

delg123
=
delgb123*f + df1*gyz[ijk]
;

delg133
=
delgb133*f + df1*gzz[ijk]
;

delg211
=
delgb211*f + df2*gxx[ijk]
;

delg212
=
delgb212*f + df2*gxy[ijk]
;

delg213
=
delgb213*f + df2*gxz[ijk]
;

delg222
=
delgb222*f + df2*gyy[ijk]
;

delg223
=
delgb223*f + df2*gyz[ijk]
;

delg233
=
delgb233*f + df2*gzz[ijk]
;

delg311
=
delgb311*f + df3*gxx[ijk]
;

delg312
=
delgb312*f + df3*gxy[ijk]
;

delg313
=
delgb313*f + df3*gxz[ijk]
;

delg322
=
delgb322*f + df3*gyy[ijk]
;

delg323
=
delgb323*f + df3*gyz[ijk]
;

delg333
=
delgb333*f + df3*gzz[ijk]
;



/* conditional */
if (confharmonic) {

gamma111
=
0
;

gamma112
=
0
;

gamma113
=
0
;

gamma122
=
0
;

gamma123
=
0
;

gamma133
=
0
;

gamma211
=
0
;

gamma212
=
0
;

gamma213
=
0
;

gamma222
=
0
;

gamma223
=
0
;

gamma233
=
0
;

gamma311
=
0
;

gamma312
=
0
;

gamma313
=
0
;

gamma322
=
0
;

gamma323
=
0
;

gamma333
=
0
;


} else { /* if (!confharmonic) */

gammado111
=
delg111/2.
;

gammado112
=
delg211/2.
;

gammado113
=
delg311/2.
;

gammado122
=
-delg122/2. + delg212
;

gammado123
=
(-delg123 + delg213 + delg312)/2.
;

gammado133
=
-delg133/2. + delg313
;

gammado211
=
delg112 - delg211/2.
;

gammado212
=
delg122/2.
;

gammado213
=
(delg123 - delg213 + delg312)/2.
;

gammado222
=
delg222/2.
;

gammado223
=
delg322/2.
;

gammado233
=
-delg233/2. + delg323
;

gammado311
=
delg113 - delg311/2.
;

gammado312
=
(delg123 + delg213 - delg312)/2.
;

gammado313
=
delg133/2.
;

gammado322
=
delg223 - delg322/2.
;

gammado323
=
delg233/2.
;

gammado333
=
delg333/2.
;

gamma111
=
gammado111*ginv11 + gammado211*ginv12 + gammado311*ginv13
;

gamma112
=
gammado112*ginv11 + gammado212*ginv12 + gammado312*ginv13
;

gamma113
=
gammado113*ginv11 + gammado213*ginv12 + gammado313*ginv13
;

gamma122
=
gammado122*ginv11 + gammado222*ginv12 + gammado322*ginv13
;

gamma123
=
gammado123*ginv11 + gammado223*ginv12 + gammado323*ginv13
;

gamma133
=
gammado133*ginv11 + gammado233*ginv12 + gammado333*ginv13
;

gamma211
=
gammado111*ginv12 + gammado211*ginv22 + gammado311*ginv23
;

gamma212
=
gammado112*ginv12 + gammado212*ginv22 + gammado312*ginv23
;

gamma213
=
gammado113*ginv12 + gammado213*ginv22 + gammado313*ginv23
;

gamma222
=
gammado122*ginv12 + gammado222*ginv22 + gammado322*ginv23
;

gamma223
=
gammado123*ginv12 + gammado223*ginv22 + gammado323*ginv23
;

gamma233
=
gammado133*ginv12 + gammado233*ginv22 + gammado333*ginv23
;

gamma311
=
gammado111*ginv13 + gammado211*ginv23 + gammado311*ginv33
;

gamma312
=
gammado112*ginv13 + gammado212*ginv23 + gammado312*ginv33
;

gamma313
=
gammado113*ginv13 + gammado213*ginv23 + gammado313*ginv33
;

gamma322
=
gammado122*ginv13 + gammado222*ginv23 + gammado322*ginv33
;

gamma323
=
gammado123*ginv13 + gammado223*ginv23 + gammado323*ginv33
;

gamma333
=
gammado133*ginv13 + gammado233*ginv23 + gammado333*ginv33
;

}
/* if (confharmonic) */


codelK111
=
oo2dx*(-kxx[-di + ijk] + kxx[di + ijk]) - 
   2*(gamma111*kxx[ijk] + gamma211*kxy[ijk] + gamma311*kxz[ijk])
;

codelK112
=
-(gamma112*kxx[ijk]) - (gamma111 + gamma212)*kxy[ijk] + 
   oo2dx*(-kxy[-di + ijk] + kxy[di + ijk]) - gamma312*kxz[ijk] - 
   gamma211*kyy[ijk] - gamma311*kyz[ijk]
;

codelK113
=
-(gamma113*kxx[ijk]) - gamma213*kxy[ijk] - (gamma111 + gamma313)*kxz[ijk] + 
   oo2dx*(-kxz[-di + ijk] + kxz[di + ijk]) - gamma211*kyz[ijk] - 
   gamma311*kzz[ijk]
;

codelK122
=
oo2dx*(-kyy[-di + ijk] + kyy[di + ijk]) - 
   2*(gamma112*kxy[ijk] + gamma212*kyy[ijk] + gamma312*kyz[ijk])
;

codelK123
=
-(gamma113*kxy[ijk]) - gamma112*kxz[ijk] - gamma213*kyy[ijk] - 
   (gamma212 + gamma313)*kyz[ijk] + oo2dx*(-kyz[-di + ijk] + kyz[di + ijk]) - 
   gamma312*kzz[ijk]
;

codelK133
=
-2*(gamma113*kxz[ijk] + gamma213*kyz[ijk] + gamma313*kzz[ijk]) + 
   oo2dx*(-kzz[-di + ijk] + kzz[di + ijk])
;

codelK211
=
oo2dy*(-kxx[-dj + ijk] + kxx[dj + ijk]) - 
   2*(gamma112*kxx[ijk] + gamma212*kxy[ijk] + gamma312*kxz[ijk])
;

codelK212
=
-(gamma122*kxx[ijk]) - (gamma112 + gamma222)*kxy[ijk] + 
   oo2dy*(-kxy[-dj + ijk] + kxy[dj + ijk]) - gamma322*kxz[ijk] - 
   gamma212*kyy[ijk] - gamma312*kyz[ijk]
;

codelK213
=
-(gamma123*kxx[ijk]) - gamma223*kxy[ijk] - (gamma112 + gamma323)*kxz[ijk] + 
   oo2dy*(-kxz[-dj + ijk] + kxz[dj + ijk]) - gamma212*kyz[ijk] - 
   gamma312*kzz[ijk]
;

codelK222
=
oo2dy*(-kyy[-dj + ijk] + kyy[dj + ijk]) - 
   2*(gamma122*kxy[ijk] + gamma222*kyy[ijk] + gamma322*kyz[ijk])
;

codelK223
=
-(gamma123*kxy[ijk]) - gamma122*kxz[ijk] - gamma223*kyy[ijk] - 
   (gamma222 + gamma323)*kyz[ijk] + oo2dy*(-kyz[-dj + ijk] + kyz[dj + ijk]) - 
   gamma322*kzz[ijk]
;

codelK233
=
-2*(gamma123*kxz[ijk] + gamma223*kyz[ijk] + gamma323*kzz[ijk]) + 
   oo2dy*(-kzz[-dj + ijk] + kzz[dj + ijk])
;

codelK311
=
oo2dz*(-kxx[-dk + ijk] + kxx[dk + ijk]) - 
   2*(gamma113*kxx[ijk] + gamma213*kxy[ijk] + gamma313*kxz[ijk])
;

codelK312
=
-(gamma123*kxx[ijk]) - (gamma113 + gamma223)*kxy[ijk] + 
   oo2dz*(-kxy[-dk + ijk] + kxy[dk + ijk]) - gamma323*kxz[ijk] - 
   gamma213*kyy[ijk] - gamma313*kyz[ijk]
;

codelK313
=
-(gamma133*kxx[ijk]) - gamma233*kxy[ijk] - (gamma113 + gamma333)*kxz[ijk] + 
   oo2dz*(-kxz[-dk + ijk] + kxz[dk + ijk]) - gamma213*kyz[ijk] - 
   gamma313*kzz[ijk]
;

codelK322
=
oo2dz*(-kyy[-dk + ijk] + kyy[dk + ijk]) - 
   2*(gamma123*kxy[ijk] + gamma223*kyy[ijk] + gamma323*kyz[ijk])
;

codelK323
=
-(gamma133*kxy[ijk]) - gamma123*kxz[ijk] - gamma233*kyy[ijk] - 
   (gamma223 + gamma333)*kyz[ijk] + oo2dz*(-kyz[-dk + ijk] + kyz[dk + ijk]) - 
   gamma323*kzz[ijk]
;

codelK333
=
-2*(gamma133*kxz[ijk] + gamma233*kyz[ijk] + gamma333*kzz[ijk]) + 
   oo2dz*(-kzz[-dk + ijk] + kzz[dk + ijk])
;

codelalphaK111
=
codelK111*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kxx[ijk]
;

codelalphaK112
=
codelK112*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kxy[ijk]
;

codelalphaK113
=
codelK113*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kxz[ijk]
;

codelalphaK122
=
codelK122*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kyy[ijk]
;

codelalphaK123
=
codelK123*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kyz[ijk]
;

codelalphaK133
=
codelK133*alp[ijk] + oo2dx*(-alp[-di + ijk] + alp[di + ijk])*kzz[ijk]
;

codelalphaK211
=
codelK211*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kxx[ijk]
;

codelalphaK212
=
codelK212*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kxy[ijk]
;

codelalphaK213
=
codelK213*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kxz[ijk]
;

codelalphaK222
=
codelK222*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kyy[ijk]
;

codelalphaK223
=
codelK223*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kyz[ijk]
;

codelalphaK233
=
codelK233*alp[ijk] + oo2dy*(-alp[-dj + ijk] + alp[dj + ijk])*kzz[ijk]
;

codelalphaK311
=
codelK311*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kxx[ijk]
;

codelalphaK312
=
codelK312*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kxy[ijk]
;

codelalphaK313
=
codelK313*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kxz[ijk]
;

codelalphaK322
=
codelK322*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kyy[ijk]
;

codelalphaK323
=
codelK323*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kyz[ijk]
;

codelalphaK333
=
codelK333*alp[ijk] + oo2dz*(-alp[-dk + ijk] + alp[dk + ijk])*kzz[ijk]
;



/* conditional */
if (minstrain) {

B1111
=
2*pow2(ginv11)
;

B1112
=
2*ginv11*ginv12
;

B1113
=
2*ginv11*ginv13
;

B1122
=
2*pow2(ginv12)
;

B1123
=
2*ginv12*ginv13
;

B1133
=
2*pow2(ginv13)
;

B1212
=
ginv11*ginv22 + pow2(ginv12)
;

B1213
=
ginv12*ginv13 + ginv11*ginv23
;

B1222
=
2*ginv12*ginv22
;

B1223
=
ginv13*ginv22 + ginv12*ginv23
;

B1233
=
2*ginv13*ginv23
;

B1313
=
ginv11*ginv33 + pow2(ginv13)
;

B1322
=
2*ginv12*ginv23
;

B1323
=
ginv13*ginv23 + ginv12*ginv33
;

B1333
=
2*ginv13*ginv33
;

B2222
=
2*pow2(ginv22)
;

B2223
=
2*ginv22*ginv23
;

B2233
=
2*pow2(ginv23)
;

B2323
=
ginv22*ginv33 + pow2(ginv23)
;

B2333
=
2*ginv23*ginv33
;

B3333
=
2*pow2(ginv33)
;


} else { /* if (!minstrain) */

B1111
=
(4*pow2(ginv11))/3.
;

B1112
=
(4*ginv11*ginv12)/3.
;

B1113
=
(4*ginv11*ginv13)/3.
;

B1122
=
(-2*ginv11*ginv22)/3. + 2*pow2(ginv12)
;

B1123
=
2*ginv12*ginv13 - (2*ginv11*ginv23)/3.
;

B1133
=
(-2*ginv11*ginv33)/3. + 2*pow2(ginv13)
;

B1212
=
ginv11*ginv22 + pow2(ginv12)/3.
;

B1213
=
(ginv12*ginv13)/3. + ginv11*ginv23
;

B1222
=
(4*ginv12*ginv22)/3.
;

B1223
=
ginv13*ginv22 + (ginv12*ginv23)/3.
;

B1233
=
2*ginv13*ginv23 - (2*ginv12*ginv33)/3.
;

B1313
=
ginv11*ginv33 + pow2(ginv13)/3.
;

B1322
=
(-2*ginv13*ginv22)/3. + 2*ginv12*ginv23
;

B1323
=
(ginv13*ginv23)/3. + ginv12*ginv33
;

B1333
=
(4*ginv13*ginv33)/3.
;

B2222
=
(4*pow2(ginv22))/3.
;

B2223
=
(4*ginv22*ginv23)/3.
;

B2233
=
(-2*ginv22*ginv33)/3. + 2*pow2(ginv23)
;

B2323
=
ginv22*ginv33 + pow2(ginv23)/3.
;

B2333
=
(4*ginv23*ginv33)/3.
;

B3333
=
(4*pow2(ginv33))/3.
;

}
/* if (minstrain) */


vlN1[ijk]
=
-(B1111*codelalphaK111) - B1122*codelalphaK122 - B1133*codelalphaK133 - 
   B1112*codelalphaK211 - B1222*codelalphaK222 - B1233*codelalphaK233 - 
   B1113*codelalphaK311 - B1322*codelalphaK322 - 
   2*(B1112*codelalphaK112 + B1113*codelalphaK113 + B1123*codelalphaK123 + 
      B1212*codelalphaK212 + B1223*codelalphaK223 + 
      B1213*(codelalphaK213 + codelalphaK312) + B1313*codelalphaK313 + 
      B1323*codelalphaK323) - B1333*codelalphaK333
;

vlN2[ijk]
=
-(B1112*codelalphaK111) - B1233*codelalphaK133 - B1122*codelalphaK211 - 
   B1222*(codelalphaK122 + 2*codelalphaK212) - B2222*codelalphaK222 - 
   B2233*codelalphaK233 - B1123*codelalphaK311 - B2223*codelalphaK322 - 
   2*(B1212*codelalphaK112 + B1213*codelalphaK113 + B1322*codelalphaK213 + 
      B2223*codelalphaK223 + B1223*(codelalphaK123 + codelalphaK312) + 
      B1323*codelalphaK313 + B2323*codelalphaK323) - B2333*codelalphaK333
;

vlN3[ijk]
=
-(B1113*codelalphaK111) - B1322*codelalphaK122 - B1123*codelalphaK211 - 
   B2223*codelalphaK222 - B1133*codelalphaK311 - 
   2*(B1213*codelalphaK112 + B1313*codelalphaK113 + B1223*codelalphaK212 + 
      B1323*(codelalphaK123 + codelalphaK213) + B2323*codelalphaK223 + 
      B1233*codelalphaK312) - B1333*(codelalphaK133 + 2*codelalphaK313) - 
   B2233*codelalphaK322 - B2333*(codelalphaK233 + 2*codelalphaK323) - 
   B3333*codelalphaK333
;



}  /* loop i, j, k */

}  /* function */

/* bamminshiftsource.c */
/* n* = 449,  n/ = 77,  n+ = 539, nvars = 26 */
