/* bamveclap.h */
/* Bernd Bruegmann, 9/99 */



/* welcome to cactus 4! */

/* blindly including everything in WaveToy.c */
#include "cctk.h" 
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"
#include "cctk_Flesh.h"
#include "cctk_Misc.h"
#include "cctk_Comm.h"
#include "CactusBase/Boundary/src/Boundary.h"
#include "CactusPUGH/PUGH/src/include/pugh.h"


/* was not needed in cactus 3 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>


/* most frequently used data access */
#define GFDataByIndex(GH, index)\
  ((CCTK_REAL *) GH->data[index][0])

/* is there a cactus 4 analog for that? */
/*
#define forallijk(GH) \
  for (ijk = 0; ijk < GH->npoints; ijk++)
*/
#define forallijk(GH) \
  for (ijk = 0, npoints = GH->cctk_lsh[0]*GH->cctk_lsh[1]*GH->cctk_lsh[2];\
       ijk < npoints; ijk++)

#define forallpoints(GH) \
  for (k = 0, di = 1, dj = GH->cctk_lsh[0],\
       dk = GH->cctk_lsh[0]*GH->cctk_lsh[1]; k < GH->cctk_lsh[2]; k++)\
  for (j = 0; j < GH->cctk_lsh[1]; j++) \
  for (i = 0, ijk = CCTK_GFINDEX3D(GH,i,j,k); i < dj /* ! */; i++, ijk++)

#define forinnerpoints(GH) \
  for (k = 1, di = 1, dj = GH->cctk_lsh[0],\
       dk = GH->cctk_lsh[0]*GH->cctk_lsh[1]; k < GH->cctk_lsh[2]-1; k++)\
  for (j = 1; j < GH->cctk_lsh[1]-1; j++) \
  for (i = 1, ijk = CCTK_GFINDEX3D(GH,i,j,k); i < dj-1 /* ! */; i++, ijk++)

#define yo() {printf("yo!\n"); fflush(stdout);}  




/* routines called directly through the schedule.ccl mechanism */
void BAM_VecLap_Shift(CCTK_ARGUMENTS);

/* routines in BAM_Elliptic */
void BAM_Elliptic_VecL(cGH *cctkGH, int *nu, int *nN, CCTK_REAL tol);
void BAM_Elliptic_Vec4(cGH *cctkGH, int *nu, int nnu, CCTK_REAL tol);

/* local routines */
void bamminshiftsource(CCTK_ARGUMENTS);
void bambctgauge(CCTK_ARGUMENTS);
void bambssngauge(CCTK_ARGUMENTS);
void bambssngauge4(CCTK_ARGUMENTS);
void setsym(cGH *GH);
extern int nocd, bssndivAfromD, bssnuseGamma;




/* cactus 4 casualty: get those grid function indices and store them */
extern int GFI_R, GFI_X, GFI_Y, GFI_Z;
extern int GFI_PSI, GFI_PSIX, GFI_PSIXX;
extern int GFI_GXX, GFI_KXX, GFI_ALP, GFI_BETAX;


/* cactus 4 casualty: get parameters by name */
int Getk(char *s, char *t);
int Geti(char *s);
double Getr8(char *s); 

