/* bound.c */
/* Bernd Bruegmann, 4/00 */

#include "cctk.h"
#include "cctk_Arguments.h"
#include "Symmetry.h"


void vlsetsyms(cGH *GH, char *name);
void vlsetsymv(cGH *GH, char *name);



void vlsetsyms(cGH *GH, char *name)
{
  int index = CCTK_VarIndex(name);
  int sym[3] = {1,1,1};

  SetCartSymVI(GH, sym, index);
}




void vlsetsymv(cGH *GH, char *name)
{
  int index = CCTK_VarIndex(name);
  int i;
  int sym[3][3] = {{-1,1,1}, {1,-1,1}, {1,1,-1}};

  for (i = 0; i < 3; i++)
    SetCartSymVI(GH, sym[i], index+i);
}




void vlsetsym(CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS 
      
  vlsetsyms(cctkGH, "bam_veclap::vldtalp");
  vlsetsymv(cctkGH, "bam_veclap::vlgg1");
  vlsetsymv(cctkGH, "bam_veclap::vlgh1");
  vlsetsymv(cctkGH, "bam_veclap::vldfup1");
}



