#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"

      subroutine ADM_BSSN_CalcAdjustment(CCTK_ARGUMENTS)
      USE ADM_BSSN_Scalars
      implicit none

      DECLARE_CCTK_ARGUMENTS
      DECLARE_CCTK_PARAMETERS

      integer i, j, k, nx, ny, nz

      CCTK_REAL ham_atten
      CCTK_REAL twothird

#include "CactusEinstein/ADMMacros/src/macro/ADM_Spacing_declare.h"

#include "macro/BSDETG_undefine.h"
#include "macro/BSUPPERMET_declare.h"
#include "macro/BSCHR2_declare.h"
#include "macro/BSHAMSTD_declare.h"
#include "macro/BSMOMSTD_declare.h"

c     Grid parameters.

      nx = cctk_lsh(1)
      ny = cctk_lsh(2)
      nz = cctk_lsh(3)

#include "CactusEinstein/ADMMacros/src/macro/ADM_Spacing.h"

      twothird = 2.0d0/3.0d0

c     Cartoon
c      call CCTK_IsImplementationActive(ierr,"cartoon2d")
c      if (ierr .ne. 0) then
      if (cartoon==1) then
         stencily = cctk_nghostzones(2)
      else
         stencily = 1
      end if

      do k=2,nz-1
        do j=1+stencily,ny-stencily
          do i=2,nx-1

#include "macro/BSDETG_undefine.h"
#include "macro/BSUPPERMET_guts.h"
#include "macro/BSCHR2_guts.h"

            constraint_Gx(i,j,k) = ADM_BS_Gx(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_XXX +
     +           BSUPPERMET_UYY * BSCHR2_XYY +
     +           BSUPPERMET_UZZ * BSCHR2_XZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_XXY +
     +                  BSUPPERMET_UXZ * BSCHR2_XXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_XYZ))
     
            constraint_Gy(i,j,k) = ADM_BS_Gy(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_YXX +
     +           BSUPPERMET_UYY * BSCHR2_YYY +
     +           BSUPPERMET_UZZ * BSCHR2_YZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_YXY +
     +                  BSUPPERMET_UXZ * BSCHR2_YXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_YYZ))

            constraint_Gz(i,j,k) = ADM_BS_Gz(i,j,k) -
     +         ( BSUPPERMET_UXX * BSCHR2_ZXX +
     +           BSUPPERMET_UYY * BSCHR2_ZYY +
     +           BSUPPERMET_UZZ * BSCHR2_ZZZ +
     +           2.0 * (BSUPPERMET_UXY * BSCHR2_ZXY +
     +                  BSUPPERMET_UXZ * BSCHR2_ZXZ +
     +                  BSUPPERMET_UYZ * BSCHR2_ZYZ))

            constraint_A(i,j,k) = 
     +           BSUPPERMET_UXX * ADM_BS_Axx(i,j,k) +
     +           BSUPPERMET_UYY * ADM_BS_Ayy(i,j,k) +
     +           BSUPPERMET_UZZ * ADM_BS_Azz(i,j,k) +
     +           2.0 * (BSUPPERMET_UXY * ADM_BS_Axy(i,j,k) +
     +                  BSUPPERMET_UXZ * ADM_BS_Axz(i,j,k) +
     +                  BSUPPERMET_UYZ * ADM_BS_Ayz(i,j,k))

            constraint_S(i,j,k) = BSDETG_DETG - 1

#include "macro/BSHAMSTD_guts.h"
#include "macro/BSMOMSTD_guts.h"

            constraint_ham(i,j,k) = BSHAMSTD_HAM

            if (BSHAMSTD_ABSHAM==0) then
               constraint_normham(i,j,k) = abs(BSHAMSTD_HAM)
            else
               constraint_normham(i,j,k) = abs(BSHAMSTD_HAM)/BSHAMSTD_ABSHAM
            end if
            constraint_momx(i,j,k) = BSMOMSTD_MOMX
            constraint_momy(i,j,k) = BSMOMSTD_MOMY
            constraint_momz(i,j,k) = BSMOMSTD_MOMZ

          end do
        end do
      end do

#include "macro/BSDETG_undefine.h"
#include "macro/BSUPPERMET_undefine.h"
#include "macro/BSCHR2_undefine.h"
#include "macro/BSHAMSTD_undefine.h"
#include "macro/BSMOMSTD_undefine.h"

      do k=2,nz-1
        do j=1+stencily,ny-stencily
          do i=2,nx-1

#include "macro/BSCHR2_guts.h"

            constraint_PG(i,j,k) = 
     +           0.5 * (constraint_Gx(i+1,j,k) - constraint_Gx(i-1,j,k)) 
     +           * idx + 
     +           0.5 * (constraint_Gy(i,j+1,k) - constraint_Gy(i,j-1,k)) 
     +           * idy +
     +           0.5 * (constraint_Gz(i,j,k+1) - constraint_Gz(i,j,k-1)) 
     +           * idz

            constraint_DMom_xx(i,j,k) =
     +           0.5 * (constraint_momx(i+1,j,k) - constraint_momx(i-1,j,k)) 
     +           * idx +
     +           ( BSCHR2_XXX * constraint_momx(i,j,k) +
     +             BSCHR2_YXX * constraint_momy(i,j,k) +
     +             BSCHR2_ZXX * constraint_momz(i,j,k) )
     
            constraint_DMom_xy(i,j,k) =
     +           0.25 * (constraint_momx(i,j+1,k) - constraint_momx(i,j-1,k)) 
     +           * idy +
     +           0.25 * (constraint_momy(i+1,j,k) - constraint_momy(i-1,j,k)) 
     +           * idx +
     +           ( BSCHR2_XXY * constraint_momx(i,j,k) +
     +             BSCHR2_YXY * constraint_momy(i,j,k) +
     +             BSCHR2_ZXY * constraint_momz(i,j,k) )

            constraint_DMom_xz(i,j,k) =
     +           0.25 * (constraint_momx(i,j,k+1) - constraint_momx(i,j,k-1)) 
     +           * idz +
     +           0.25 * (constraint_momz(i+1,j,k) - constraint_momz(i-1,j,k)) 
     +           * idx +
     +           ( BSCHR2_XXZ * constraint_momx(i,j,k) +
     +             BSCHR2_YXZ * constraint_momy(i,j,k) +
     +             BSCHR2_ZXZ * constraint_momz(i,j,k) )

            constraint_DMom_yy(i,j,k) =
     +           0.5 * (constraint_momy(i,j+1,k) - constraint_momy(i,j-1,k)) 
     +           * idy -
     +           ( BSCHR2_XYY * constraint_momx(i,j,k) +
     +             BSCHR2_YYY * constraint_momy(i,j,k) +
     +             BSCHR2_ZYY * constraint_momz(i,j,k) )
     
            constraint_DMom_yz(i,j,k) =
     +           0.25 * (constraint_momy(i,j,k+1) - constraint_momy(i,j,k-1)) 
     +           * idz +
     +           0.25 * (constraint_momz(i,j+1,k) - constraint_momz(i,j-1,k)) 
     +           * idy +
     +           ( BSCHR2_XYZ * constraint_momx(i,j,k) +
     +             BSCHR2_YYZ * constraint_momy(i,j,k) +
     +             BSCHR2_ZYZ * constraint_momz(i,j,k) )

            constraint_DMom_zz(i,j,k) =
     +           0.5 * (constraint_momz(i,j,k+1) - constraint_momz(i,j,k-1)) 
     +           * idz +
     +           ( BSCHR2_XZZ * constraint_momx(i,j,k) +
     +             BSCHR2_YZZ * constraint_momy(i,j,k) +
     +             BSCHR2_ZZZ * constraint_momz(i,j,k) )

            constraint_DMom(i,j,k) =
     +         ( BSUPPERMET_UXX * constraint_DMom_xx(i,j,k) +
     +           BSUPPERMET_UYY * constraint_DMom_yy(i,j,k) +
     +           BSUPPERMET_UZZ * constraint_DMom_zz(i,j,k) +
     +           2.0 * (BSUPPERMET_UXY * constraint_DMom_xy(i,j,k) +
     +                  BSUPPERMET_UXZ * constraint_DMom_xz(i,j,k) +
     +                  BSUPPERMET_UYZ * constraint_DMom_yz(i,j,k)))

          end do
        end do
      end do

#include "macro/BSCHR2_undefine.h"

      end subroutine ADM_BSSN_CalcAdjustment





