/*@@
  @header   RICCIPHI_guts.h
  @date     Nov 98
  @author   Gabrielle Allen
  @desc
  Macro for the components of the "Ricci" tensor for the BS 
  variable phi. Eq. 20 of the BS paper.
  @enddesc
@@*/


#ifndef RICCIPHI_GUTS
#define RICCIPHI_GUTS

#include "macro/CDCDPHI_guts.h"
#include "macro/DPHI_guts.h"
#include "macro/NABPHI_guts.h"
#include "macro/BSUPPERMET_guts.h"

      RICCIPHI_TEMP = BSUPPERMET_UXX*DPHI_DXDPHI*DPHI_DXDPHI
     &              + BSUPPERMET_UYY*DPHI_DYDPHI*DPHI_DYDPHI
     &              + BSUPPERMET_UZZ*DPHI_DZDPHI*DPHI_DZDPHI
     &              +(BSUPPERMET_UXY*DPHI_DXDPHI*DPHI_DYDPHI
     &              + BSUPPERMET_UXZ*DPHI_DXDPHI*DPHI_DZDPHI
     &              + BSUPPERMET_UYZ*DPHI_DYDPHI*DPHI_DZDPHI)*2.0d0

      RICCIPHI_RXX = - 2.0d0*(CDCDPHI_CDXXDPHI + RICCIPHI_GXX*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DXDPHI*DPHI_DXDPHI - RICCIPHI_GXX*RICCIPHI_TEMP)

      RICCIPHI_RXY = - 2.0d0*(CDCDPHI_CDXYDPHI + RICCIPHI_GXY*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DXDPHI*DPHI_DYDPHI - RICCIPHI_GXY*RICCIPHI_TEMP)

      RICCIPHI_RXZ = - 2.0d0*(CDCDPHI_CDXZDPHI + RICCIPHI_GXZ*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DXDPHI*DPHI_DZDPHI - RICCIPHI_GXZ*RICCIPHI_TEMP)

      RICCIPHI_RYY = - 2.0d0*(CDCDPHI_CDYYDPHI + RICCIPHI_GYY*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DYDPHI*DPHI_DYDPHI - RICCIPHI_GYY*RICCIPHI_TEMP)

      RICCIPHI_RYZ = - 2.0d0*(CDCDPHI_CDYZDPHI + RICCIPHI_GYZ*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DYDPHI*DPHI_DZDPHI - RICCIPHI_GYZ*RICCIPHI_TEMP)

      RICCIPHI_RZZ = - 2.0d0*(CDCDPHI_CDZZDPHI + RICCIPHI_GZZ*NABPHI_NABPHI)
     &        + 4.0d0*(DPHI_DZDPHI*DPHI_DZDPHI - RICCIPHI_GZZ*RICCIPHI_TEMP)

#endif
