/*@@
  @file    $RCSfile: cctk_Stagger.F90,v $
  @author  $Author: schnetter $
  @date    $Date: 2005/04/16 15:30:37 $
  @desc
           Fortran 90 interface declarations for the routines
           which have their C declarations in cctk_Stagger.h
  @enddesc
  @version $Header: /numrelcvs/AEIThorns/Fortran/src/cctk_Stagger.F90,v 1.1 2005/04/16 15:30:37 schnetter Exp $
@@*/

#include "cctk.h"

module cctk_Stagger
  implicit none

  interface

     subroutine CCTK_GroupStaggerIndexGI (sindex, gindex)
       implicit none
       integer sindex
       integer gindex
     end subroutine CCTK_GroupStaggerIndexGI
     
     subroutine CCTK_GroupStaggerIndexGN (sindex, gname)
       implicit none
       integer      sindex
       character(*) gname
     end subroutine CCTK_GroupStaggerIndexGN
     
     subroutine CCTK_StaggerIndex (sindex, stype)
       implicit none
       integer      sindex
       character(*) stype
     end subroutine CCTK_StaggerIndex
     
     subroutine CCTK_StaggerDirIndex (dindex, dir, scode)
       implicit none
       integer dindex
       integer dir
       integer scode
     end subroutine CCTK_StaggerDirIndex
     
     subroutine CCTK_StaggerDirArray (ierr, dindex, dir, sindex)
       implicit none
       integer ierr
       integer dindex(*)
       integer dir
       integer sindex
     end subroutine CCTK_StaggerDirArray
     
     subroutine CCTK_GroupStaggerDirArrayGI (ierr, dindex, dir, gi)
       implicit none
       integer ierr
       integer dindex(*)
       integer dir
       integer gi
     end subroutine CCTK_GroupStaggerDirArrayGI
     
     subroutine CCTK_StaggerDirName (scode, dir, stype)
       implicit none
       integer      scode
       integer      dir
       character(*) stype
     end subroutine CCTK_StaggerDirName
     
     subroutine CCTKi_ParseStaggerString (scode, dim, imp, gname, stype)
       implicit none
       integer      scode
       integer      dim
       character(*) imp
       character(*) gname
       integer      stype
     end subroutine CCTKi_ParseStaggerString
     
  end interface
  
end module cctk_Stagger
