/*@@
  @file    $RCSfile: cctk_WarnLevel.F90,v $
  @author  $Author: schnetter $
  @date    $Date: 2005/05/06 21:39:05 $
  @desc
           Fortran 90 interface declarations for the routines
           which have their C declarations in cctk_WarnLevel.h
  @enddesc
  @version $Header: /numrelcvs/AEIThorns/Fortran/src/cctk_WarnLevel.F90,v 1.2 2005/05/06 21:39:05 schnetter Exp $
@@*/

#include "cctk.h"

module cctk_WarnLevel
  implicit none

  interface

     subroutine CCTK_Warn (level, line, file, thorn, message)
       implicit none
       integer      level
       integer      line
       character(*) file
       character(*) thorn
       character(*) message
     end subroutine CCTK_Warn

     subroutine CCTK_ParamWarn (thorn, message)
       implicit none
       character(*) thorn
       character(*) message
     end subroutine CCTK_ParamWarn

     subroutine CCTK_Info (thorn, message)
       implicit none
       character(*) thorn
       character(*) message
     end subroutine CCTK_Info
     
  end interface
  
  ! Do not declare these, because some compilers insist on a
  ! definition once they have seen an external declaration:
!!$  external CCTK_VWarn
!!$  external CCTK_VParamWarn
!!$  external CCTK_VInfo
  
end module cctk_WarnLevel
