! $Header: /numrelcvs/AEIThorns/HyperWave/src/Constraints.F90,v 1.4 2005/07/01 13:07:01 schnetter Exp $

! Evaluate the constraints:
! w_i = epsilon_ijk D_j v_k

! We use the Fortran array notation here.
! Note that vx, vy, vz, wx, wy, and wz are 3D arrays.

#include "cctk.h"
#include "cctk_Arguments.h"

subroutine HW_Constraints (CCTK_ARGUMENTS)
  implicit none
  DECLARE_CCTK_ARGUMENTS
  
  ! Some local arrays
  CCTK_REAL, dimension(cctk_lsh(1), cctk_lsh(2), cctk_lsh(3)) &
       :: dyvx, dzvx, dxvy, dzvy, dxvz, dyvz
  
  ! Calculate the derivatives
  call Diff_gv (cctkGH, 1, vx, dyvx, -1)
  call Diff_gv (cctkGH, 2, vx, dzvx, -1)
  call Diff_gv (cctkGH, 0, vy, dxvy, -1)
  call Diff_gv (cctkGH, 2, vy, dzvy, -1)
  call Diff_gv (cctkGH, 0, vz, dxvz, -1)
  call Diff_gv (cctkGH, 1, vz, dyvz, -1)
  
  ! Calculate the constraints
  wx = dyvz - dzvy
  wy = dzvx - dxvz
  wz = dxvy - dyvx
  
end subroutine HW_Constraints
