/* $Header: /numrelcvs/AEIThorns/HyperWave/src/Setup.c,v 1.1 2004/12/16 13:30:13 schnetter Exp $ */

/* Register the evolved variables with the time integrator.  */

#include "cctk.h"
#include "cctk_Arguments.h"

void
HW_Setup (CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS;
  
  int ierr1, ierr2, ierr3;      /* Error codes */
  
  /* Register the evolved variables and their RHSs */
  ierr1 = MoLRegisterEvolvedGroup
    (CCTK_GroupIndex ("HyperWave::scalar"),
     CCTK_GroupIndex ("HyperWave::scalar_rhs"));
  ierr2 = MoLRegisterEvolvedGroup
    (CCTK_GroupIndex ("HyperWave::scalar_dot"),
     CCTK_GroupIndex ("HyperWave::scalar_dot_rhs"));
  ierr3 = MoLRegisterEvolvedGroup
    (CCTK_GroupIndex ("HyperWave::scalar_grad"),
     CCTK_GroupIndex ("HyperWave::scalar_grad_rhs"));
  
  /* Abort if there was an error */
  if (ierr1 != 0 || ierr2 != 0 || ierr3 != 0) {
    CCTK_WARN (0, "Could not register evolved variables");
  }
}
