 /*@@
   @header    ioAHFinderHDF5GH.h
   @date      Sun 5 Aug 2001
   @author    Thomas Radke
   @desc
              The extensions to the GH structure from IOAHFinderHDF5.
   @enddesc
   @version   $Header: /numrelcvs/AEIThorns/IOAHFinderHDF5/src/ioAHFinderHDF5GH.h,v 1.9 2004/06/21 16:26:33 tradke Exp $
 @@*/

#ifndef _IOAHFINDERHDF5_IOAHFINDERHDF5GH_H_
#define _IOAHFINDERHDF5_IOAHFINDERHDF5GH_H_ 1

#include <hdf5.h>

#include "SocketUtils.h"
#include "CactusPUGHIO/IOHDF5Util/src/ioHDF5UtilGH.h"


typedef struct IOAHFINDERHDF5GH
{
  /* HDF5 handles for the current files and their toplevel groups */
  hid_t stream, file, time_group_stream, time_group_file;

  /* port and socket to stream out AHFinder HDF5 data */
  unsigned int port;
  SOCKET socket;

  /* filename for advertising the hostname / port number information */
  char advertised_filename[L_tmpnam];

  /* number of iterations this I/O method was called */
  unsigned int ntimes_called;

  /* number of times the 'IOAHFinderHDF5::out_vars' parameter was set */
  int out_vars_lastset;

  /* I/O request descriptions for all CCTK variables */
  ioRequest **requests;

} ioAHFinderHDF5GH;


#ifdef __cplusplus
extern "C"
{
#endif

/* function prototypes */
int IOAHFinderHDF5_OutputVarAs (const cGH *GH, const char *fullname,
                                const char *alias);
#ifdef __cplusplus
} // extern "C"
#endif

#endif /* _IOAHFINDERHDF5_IOAHFINDERHDF5GH_H_ */
