# gnuplot script to show interpolation errors

set sty data points
set xzeroaxis

set title 'interpolation errors (4-point molecules)
set key below

set ylabel 'fn errors'
set yrange [-3e-4:3e-4]

set y2tics
set y2label 'deriv errors'
set y2range [-2e-2:2e-2]

plot '1d-Lagrange-fn-order3-0.1.dat' using 1:6,		\
     '1d-Hermite-fn-order2-0.1.dat' using 1:6,		\
							\
     '1d-Lagrange-deriv-order3-0.1.dat' using 1:6 axis x1y2,	\
     '1d-Hermite-deriv-order2-0.1.dat' using 1:6 axis x1y2
