// data_ptrs.hh -- store pointers to data arrays of all the different data types
// pointers to input arrays on the current processor

//
// A  data_ptrs  object stores a set of pointers to data arrays, one array
// for each of the Cactus data types we test.
//
struct	data_ptrs
	{
	CCTK_REAL*      ptr_real;
	CCTK_REAL4*     ptr_real4;
	CCTK_REAL8*     ptr_real8;
	CCTK_COMPLEX*   ptr_complex;
	CCTK_COMPLEX8*  ptr_complex8;
	CCTK_COMPLEX16* ptr_complex16;

	// select one of the ptr_* pointers, cast to void*
	// n.b. itype is an int so we can iterate over it with a for loop
	void* select_ptr(int itype) const;

	// default constructor -- no initialization done
	data_ptrs() { }

	// GH pointer supplied -- set to point to Cactus data arrays
	//                        on this processor
	data_ptrs(const cGH* GH);
	};
