// test_norm -- quick-n-dirty test of norm template class
// $Header: /numrelcvs/AEIThorns/TestInterpBase/src/test_norm.cc,v 1.2 2003/01/17 15:23:13 jthorn Exp $

#include <stdio.h>
#include <math.h>
#include <assert.h>

#ifdef TESTINTERP_STANDALONE_BUILD
  #include "fake_cctk.h"
#else
  #include "cctk.h"
#endif

#include "stdc.h"
#include "fp.h"
#include "util.hh"

//
// This program tests the  jtutil::norm  class.
//
int main()
{
jtutil::norm<double> foo;
assert(  foo.is_empty()   );
assert(! foo.is_nonempty());
foo.data(3.0);
assert(! foo.is_empty()   );
assert(  foo.is_nonempty());
foo.data(-3.0);
foo.data(3.0);
foo.data(-3.0);
foo.data(-3.0);
printf("foo.two_norm() = %g (should be 3*sqrt(5)=6.708)\n", foo.two_norm());
printf("foo.rms_norm() = %g (should be 3.0)\n", foo.rms_norm());
printf("foo.infinity_norm() = %g (should be 3.0)\n", foo.infinity_norm());

printf("\n");
foo.reset();
assert(  foo.is_empty()   );
assert(! foo.is_nonempty());

foo.data(-3.0);
assert(! foo.is_empty()   );
assert(  foo.is_nonempty());
foo.data(1.0);
foo.data(-4.0);
foo.data(2.0);
foo.data(-5.0);
printf("foo.two_norm() = %g (should be sqrt(55)=7.416)\n", foo.two_norm());
printf("foo.rms_norm() = %g (should be sqrt(11)=3.317)\n", foo.rms_norm());
printf("foo.infinity_norm() = %g (should be 5.0)\n", foo.infinity_norm());

return 0;
}
