#! /usr/bin/perl -w
#/*@@
#  @file      ConfigureWithPBS.pl
#  @date      Wednesday 1 December 2004
#  @author    Thomas Radke
#  @desc
#             Configures TriggerTermination with an external PBS installation
#  @enddesc
#  @version   $Header: /numrelcvs/AEIThorns/TriggerTermination/ConfigureWithPBS.pl,v 1.2 2005/09/20 08:55:02 tradke Exp $
#@@*/

# either PBS_DIR or {PBS_INC_DIR, PBS_LIB_DIR} must be given by the user
my $pbs_inc_dir = $ENV{'PBS_INC_DIR'};
my $pbs_lib_dir = $ENV{'PBS_LIB_DIR'};
my $pbsdir      = $ENV{'PBS_DIR'};
if (! (($pbs_inc_dir && $pbs_lib_dir) || $pbsdir)) {
  print "BEGIN ERROR\n";
  print "TriggerTermination requires an external PBS installation. " .
        "Please specify either PBS_DIR or {PBS_INC_DIR, PBS_LIB_DIR} to point ".
        "to this installation or remove thorn TriggerTermination from your ThornList !\n";
  print "END ERROR\n";
  exit (-1);
}
$pbs_inc_dir = "$pbsdir/include" if (! $pbs_inc_dir);
$pbs_lib_dir = "$pbsdir/lib"     if (! $pbs_lib_dir);
$pbs_inc_dir =~ s/(.*)\/+$/$1/;
$pbs_lib_dir =~ s/(.*)\/+$/$1/;

# check if $pbs_inc_dir really contains what we need
if (! -r "$pbs_inc_dir/pbs_error.h") {
  print "BEGIN ERROR\n";
  print "Couldn't find PBS header file pbs_error.h in '$pbs_inc_dir/'. " .
        "Did you set \$\{PBS_DIR\} or \$\{PBS_INC_DIR, PBS_LIB_DIR\} correctly ?\n";
  print "END ERROR\n";
  exit (-1);
}

# exclude standard paths from LIB_DIRS and INC_DIRS
# FIXME: Intel icc does NOT have /usr/local/include in its default search path
print "INCLUDE_DIRECTORY $pbs_inc_dir\n" if ($pbs_inc_dir ne '/usr/include');
print "LIBRARY_DIRECTORY $pbs_lib_dir\n" if ($pbs_lib_dir ne '/usr/lib');
print 'LIBRARY pbs';

exit (0);
