 /*@@
   @file      ParamCheck.c
   @date      November 1999
   @author    Gabrielle Allen
   @desc 
      Check parameters for ADM
   @enddesc 
 @@*/

#include <stdio.h>
#include <stdlib.h>

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

static char *rcsid = "$Header: /cactusdevcvs/CactusBench/BenchADM/src/ParamCheck.c,v 1.11 2004/05/17 12:28:55 goodale Exp $";

CCTK_FILEVERSION(CactusBench_BenchADM_ParamCheck_c)

void Bench_ParamCheck(CCTK_ARGUMENTS);

 /*@@
   @routine    ParamChecker
   @date       November 1999
   @author     Gabrielle Allen
   @desc 
      Check parameters for ADM
   @enddesc 
   @calls     
   @history 
 
   @endhistory 

@@*/

void Bench_ParamCheck(CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS

  CCTK_INFO("Evolve using the ADM system");

  if (CCTK_Equals(method,"stagleap")) 
  {
    CCTK_INFO("  with staggered leapfrog");
  }

  /* Check for problems with courant */

  if (CCTK_Equals(timestep_method,"courant_speed") 
      || CCTK_Equals(timestep_method,"courant_time")) 
  {
    if (!timestep_outonly) 
    {
      if (CCTK_Equals(method,"stagleap")) 
      {
        CCTK_WARN(0,"Staggered Leapfrog and Courant are Incompatible");
      }
      else if (CCTK_Equals(method,"leapfrog")) 
      {
        CCTK_WARN(2, "Leapfrog and Courant are untested");
      }
    }
    
  }

  return;  

}

