 /*@@
   @file      EOS_1D_Base.h
   @date      May 2000
   @author    Mark Miller
   @desc 
   Header file for EOS_1D basic functions
   @enddesc 
   @versions 
 @@*/

#ifndef _EOS_1D_BASE_H_
#define _EOS_1D_BASE_H_

#ifdef __cplusplus 
extern "C" 
{
#endif

int EOS_1D_RegisterMethod(const char *name);
int EOS_1D_Handle(const char *name);


#define EOS_1D_REGISTER_FUNCTION(x) int EOS_1D_Register ## x (int , CCTK_REAL (*func)(CCTK_REAL))
#define EOS_1D_CALL_FUNCTION(x) CCTK_REAL EOS_1D_ ## x (int , CCTK_REAL)

EOS_1D_REGISTER_FUNCTION(pressfromrho);
EOS_1D_REGISTER_FUNCTION(pressfromeps);
EOS_1D_REGISTER_FUNCTION(epsfromrho);
EOS_1D_REGISTER_FUNCTION(epsfrompress);
EOS_1D_REGISTER_FUNCTION(rhofrompress);
EOS_1D_REGISTER_FUNCTION(rhofromeps);

EOS_1D_CALL_FUNCTION(pressfromrho);
EOS_1D_CALL_FUNCTION(pressfromeps);
EOS_1D_CALL_FUNCTION(epsfromrho);
EOS_1D_CALL_FUNCTION(epsfrompress);
EOS_1D_CALL_FUNCTION(rhofrompress);
EOS_1D_CALL_FUNCTION(rhofromeps);

#ifdef __cplusplus 
}
#endif

#endif /* EOS_1D_Base.h */
