 /*@@
   @file      Call.c
   @date      Tue Dec 14 23:52:29 1999
   @author    Tom Goodale
   @desc 
   Calls the Fortran EOS test routines from C
   @enddesc 
 @@*/

static const char *rcsid = "$Header: /arrangements/CactusEOS/EOS_Test/src/Call.c,v 1.3 2001/05/10 12:36:41 goodale Exp $";

#include <stdio.h>

#include "cctk.h"
#include "cctk_Arguments.h"

#include "EOS_Base.h"

 /*@@
   @routine    EOS_Test_Call
   @date       Wed Dec 15 00:02:07 1999
   @author     Tom Goodale
   @desc 
   Test calling of EOS functions from C.
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
void EOS_Test_Call(CCTK_CARGUMENTS)
{
  DECLARE_CCTK_CARGUMENTS

  CCTK_REAL rho, eps, p, dpdrho, dpdeps;

  int handle;

  printf("Testing EOS from C\n");

  handle = EOS_Handle("test_f");

  if(handle >= 0)
  {
    p = EOS_Pressure(handle, 3.0, 4.0);

    printf("p = %f\n", p);

    eps = EOS_SpecificIntEnergy(handle, 3.0, 4.0);
    
    printf("eps = %f\n", eps);

    rho = EOS_RestMassDens(handle, 3.0, 4.0);
    
    printf("rho = %f\n", rho);
  
    dpdrho = EOS_DPressByDRho(handle, 3.0, 4.0);

    printf("dpdrho = %f\n", dpdrho);

    dpdeps = EOS_DPressByDEps(handle, 3.0, 4.0);

    printf("dpdeps = %f\n", dpdeps);
  }
  else
  {
    printf("Can't find an EOS handle for 'test_f'.\n");
  }

}
