c/*@@
c  @file      Startup.F
c  @date      Tue Dec 14 22:41:13 1999
c  @author    Tom Goodale
c  @desc 
c  Fortran startup for EOS test
c  @enddesc 
c  @version $Header: /arrangements/CactusEOS/EOS_Test/src/Startup.F,v 1.1.1.1 1999/12/16 13:28:36 goodale Exp $
c@@*/

#include "cctk.h"

c/*@@
c  @routine    EOS_Test_Startup
c  @date       Tue Dec 14 22:48:15 1999
c  @author     Tom Goodale
c  @desc 
c  
c  @enddesc 
c  @calls      EOS_RegisterMethod EOS_RegisterPressure EOS_RegisterSpecificInternalEnergy EOS_RegisterRestMassDens EOS_RegisterDPressByDRho EOS_RegisterDPressByDEps CCTK_WARN
c  @calledby   
c  @history 
c
c  @endhistory 
c@@*/

      INTEGER FUNCTION EOS_Test_Startup()

      IMPLICIT NONE

      INTEGER handle
      INTEGER ierr

      EXTERNAL EOS_Test_Pressure
      EXTERNAL EOS_Test_SpecificIE
      EXTERNAL EOS_Test_RestMassDens
      EXTERNAL EOS_Test_DPressByDRho
      EXTERNAL EOS_Test_DPressByDEps

      call EOS_RegisterMethod(handle, "test_f")

      IF(handle .ge. 0) THEN

        CALL EOS_RegisterPressure(ierr, handle, EOS_Test_Pressure);
        CALL EOS_RegisterSpecificIntEnergy(ierr, handle, EOS_Test_SpecificIE);
        CALL EOS_RegisterRestMassDens(ierr, handle, EOS_Test_RestMassDens);
        CALL EOS_RegisterDPressByDRho(ierr, handle, EOS_Test_DPressByDRho);
        CALL EOS_RegisterDPressByDEps(ierr, handle, EOS_Test_DPressByDEps);

      ELSE
         
         call CCTK_WARN(0, "Unable to register an EOS method from fortran 8-(")

      ENDIF

      EOS_Test_Startup = 0

      END FUNCTION EOS_Test_Startup
