c/*@@
c  @file      Test.F
c  @date      Tue Dec 14 23:05:06 1999
c  @author    Tom Goodale
c  @desc 
c     Fortran EOS test functions
c  @enddesc 
c  @version $Header: /arrangements/CactusEOS/EOS_Test/src/Test.F,v 1.1.1.1 1999/12/16 13:28:36 goodale Exp $
c@@*/

#include "cctk.h"

c/*@@
c  @routine    EOS_Test_Pressure
c  @date       Tue Dec 14 23:13:53 1999
c  @author     Tom Goodale
c  @desc 
c    Fortran test of EOS pressure
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c
c@@*/
      CCTK_REAL FUNCTION EOS_Test_Pressure(rest_mass_density, specific_internal_energy)

      IMPLICIT NONE

      CCTK_REAL rest_mass_density
      CCTK_REAL specific_internal_energy

      EOS_Test_Pressure = 2.0 *  rest_mass_density

      END FUNCTION EOS_Test_Pressure

c/*@@
c  @routine    EOS_Test_SpecificIE
c  @date       Tue Dec 14 23:13:53 1999
c  @author     Tom Goodale
c  @desc 
c    Fortran test of EOS SpecificInternalEnergy
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c
c@@*/
      CCTK_REAL FUNCTION EOS_Test_SpecificIE(rest_mass_density, pressure)

      IMPLICIT NONE

      CCTK_REAL rest_mass_density
      CCTK_REAL pressure

      EOS_Test_SpecificIE = 3.0 *  rest_mass_density

      END FUNCTION EOS_Test_SpecificIE

c/*@@
c  @routine    EOS_Test_RestMassDens
c  @date       Tue Dec 14 23:13:53 1999
c  @author     Tom Goodale
c  @desc 
c    Fortran test of EOS RestMassDens
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c
c@@*/
      CCTK_REAL FUNCTION EOS_Test_RestMassDens(specific_internal_energy, pressure)

      IMPLICIT NONE

      CCTK_REAL specific_internal_energy
      CCTK_REAL pressure

      EOS_Test_RestMassDens = 0.5*pressure

      END FUNCTION EOS_Test_RestMassDens

c/*@@
c  @routine    EOS_Test_DPressByDRho
c  @date       Tue Dec 14 23:13:53 1999
c  @author     Tom Goodale
c  @desc 
c    Fortran test of EOS DPressByDRho
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c
c@@*/
      CCTK_REAL FUNCTION EOS_Test_DPressByDRho(rest_mass_density, specific_internal_energy)

      IMPLICIT NONE

      CCTK_REAL rest_mass_density
      CCTK_REAL specific_internal_energy

      EOS_Test_DPressByDRho = 0.5

      END FUNCTION EOS_Test_DPressByDRho

c/*@@
c  @routine    EOS_Test_DPressByDEps
c  @date       Tue Dec 14 23:13:53 1999
c  @author     Tom Goodale
c  @desc 
c    Fortran test of EOS DPressByDEps
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c
c@@*/
      CCTK_REAL FUNCTION EOS_Test_DPressByDEps(rest_mass_density, specific_internal_energy)

      IMPLICIT NONE

      CCTK_REAL rest_mass_density
      CCTK_REAL specific_internal_energy

      EOS_Test_DPressByDEps = 1.5

      END FUNCTION EOS_Test_DPressByDEps
