 /*@@
   @file      Test.c
   @date      Tue Dec 14 22:51:13 1999
   @author    Tom Goodale
   @desc 
   C EOS test functions
   @enddesc 
 @@*/

static const char *rcsid = "$Header: /arrangements/CactusEOS/EOS_Test/src/Test.c,v 1.2 2001/05/10 12:36:41 goodale Exp $";

#include "cctk.h"

#include "EOS_Test.h"

 /*@@
   @routine    EOS_Test_Pressure
   @date       Tue Dec 14 23:03:29 1999
   @author     Tom Goodale
   @desc 
   Test function for EOS pressure routines
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
CCTK_REAL EOS_Test_Pressure(CCTK_REAL rest_mass_density, 
                            CCTK_REAL specific_internal_energy)
{
  return rest_mass_density;
}

 /*@@
   @routine    EOS_Test_SpecificIntEnergy
   @date       Tue Dec 14 23:03:29 1999
   @author     Tom Goodale
   @desc 
   Test function for EOS SpecificInternalEnergy routines
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
CCTK_REAL EOS_Test_SpecificIntEnergy(CCTK_REAL rest_mass_density,
                                     CCTK_REAL pressure)
{
  return 1.0;
}

 /*@@
   @routine    EOS_Test_RestMassDens
   @date       Tue Dec 14 23:03:29 1999
   @author     Tom Goodale
   @desc 
   Test function for EOS RestMassDens routines
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
CCTK_REAL EOS_Test_RestMassDens(CCTK_REAL specific_internal_energy,
                                CCTK_REAL pressure)
{
  return pressure;
}

 /*@@
   @routine    EOS_Test_DPressByDRho
   @date       Tue Dec 14 23:03:29 1999
   @author     Tom Goodale
   @desc 
   Test function for EOS DPressByDRho routines
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
CCTK_REAL EOS_Test_DPressByDRho(CCTK_REAL rest_mass_density,
                                CCTK_REAL specific_internal_energy)
{
  return 2.0;
}

 /*@@
   @routine    EOS_Test_DPressByDEps
   @date       Tue Dec 14 23:03:29 1999
   @author     Tom Goodale
   @desc 
   Test function for EOS DPressByDEps routines
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/
CCTK_REAL EOS_Test_DPressByDEps(CCTK_REAL rest_mass_density,
                                CCTK_REAL specific_internal_energy)
{
  return 3.0;
}

