 /*@@
   @file    SetSym.F
   @date    March 1999
   @author  Gabrielle Allen
   @desc
            Sets the symmetries for the ADM grid functions
   @enddesc
 @@*/


#define DEBUG_BOUND

#include "cctk.h"
#include "cctk_Arguments.h"


 /*@@
   @routine    ADMSetSym
   @date       March 1999
   @author     Gabrielle Allen
   @desc 
               Sets the symmetries for the ADM grid functions
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/

      subroutine ADMSetSym(CCTK_ARGUMENTS)

      implicit none
      
      DECLARE_CCTK_ARGUMENTS 
      
      INTEGER, PARAMETER :: one = 1
      INTEGER, DIMENSION(3) :: sym
      INTEGER :: ierr

c     GROUP: ADM_lapse_prev
      sym(1) = one
      sym(2) = one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_alp_p')

c     GROUP: ADM_metric_prev
      sym(1) = one
      sym(2) = one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_gxx_p')
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_gyy_p')
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_gzz_p')
      sym(1) = -one
      sym(2) = -one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_gxy_p')
      sym(1) = -one
      sym(2) =  one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_gxz_p')
      sym(1) =  one
      sym(2) = -one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym, 'adm::ADM_gyz_p')

c     GROUP: ADM_curv_prev
      sym(1) = one
      sym(2) = one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxx_p')
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kyy_p')
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kzz_p')
      sym(1) = -one
      sym(2) = -one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxy_p')
      sym(1) = -one
      sym(2) =  one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxz_p')
      sym(1) =  one
      sym(2) = -one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kyz_p')

c     GROUP: ADM_curv_stag
      sym(1) = one
      sym(2) = one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxx_stag')
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kyy_stag')
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kzz_stag')
      sym(1) = -one
      sym(2) = -one
      sym(3) = one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxy_stag')
      sym(1) = -one
      sym(2) =  one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kxz_stag')
      sym(1) =  one
      sym(2) = -one
      sym(3) = -one
      call SetCartSymVN(ierr,cctkGH, sym,'adm::ADM_kyz_stag')

      return

      end subroutine ADMSetSym



