
#include "cctk.h"
#include "cctk_Parameters.h"
#include "Slicing.h"

static const char *rcsid = "$Header: /cactusdevcvs/CactusEinstein/ADM/src/Startup.c,v 1.16 2002/04/26 13:23:52 goodale Exp $";

CCTK_FILEVERSION(CactusEinstein_ADM_Startup_c)

void ADMRegisterSlicing(void);

 /*@@
   @routine    ADMRegisterSlicing
   @date       Fri Jul 21 13:19:51 2000
   @author     Gerd Lanfermann
   @desc 
      routine registers the slicings which are provided in 
      ADM
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/

void ADMRegisterSlicing(void) 
{

  DECLARE_CCTK_PARAMETERS

  int ADMtimetoslice(cGH *GH);
  int handle;

  if (CCTK_Equals(evolution_method,"ADM")) 
  {
    handle=Einstein_RegisterSlicing("harmonic");
    if (handle<0) CCTK_WARN(1,"Cannot register harmonic slicing");
    handle=Einstein_RegisterSlicing("1+log");
    if (handle<0) CCTK_WARN(1,"Cannot register 1+log slicing");
    handle=Einstein_RegisterSlicing("detg");
    if (handle<0) CCTK_WARN(1,"Cannot register detg slicing"); 
  }

  return;

}  

   

