
#ifndef KSOURCES_GUTS
#define KSOURCES_GUTS

c              This may be needed for CalcTmunu etc
#include "CactusEinstein/ADMMacros/src/macro/DETG_guts.h"
               det = DETG_DETCG
#include "CactusEinstein/ADMMacros/src/macro/UPPERMET_guts.h"
               uxx = UPPERMET_UXX; uxy = UPPERMET_UXY; uxz = UPPERMET_UXZ
               uyy = UPPERMET_UYY; uyz = UPPERMET_UYZ; uzz = UPPERMET_UZZ

c     Contribution from the stress-energy tensor to K evolution equation

      Ttt = 0.0D0; Ttx = 0.0D0; Tty = 0.0D0; Ttz = 0.0D0
      Txx = 0.0D0; Txy = 0.0D0; Txz = 0.0D0
      Tyy = 0.0D0; Tyz = 0.0D0
      Tzz = 0.0D0

#include "CalcTmunu.inc"

#include "CactusEinstein/ADMMacros/src/macro/TRT_guts.h"

      adm_rhsK_matter_xx = -8D0*alp(i,j,k)*pi*(Txx-0.5D0*gxx(i,j,k)*TRT_TRT)
      adm_rhsK_matter_xy = -8D0*alp(i,j,k)*pi*(Txy-0.5D0*gxy(i,j,k)*TRT_TRT)
      adm_rhsK_matter_xz = -8D0*alp(i,j,k)*pi*(Txz-0.5D0*gxz(i,j,k)*TRT_TRT)
      adm_rhsK_matter_yy = -8D0*alp(i,j,k)*pi*(Tyy-0.5D0*gyy(i,j,k)*TRT_TRT)
      adm_rhsK_matter_yz = -8D0*alp(i,j,k)*pi*(Tyz-0.5D0*gyz(i,j,k)*TRT_TRT)
      adm_rhsK_matter_zz = -8D0*alp(i,j,k)*pi*(Tzz-0.5D0*gzz(i,j,k)*TRT_TRT)


c     Contribution from the spacetime geometry to K evolution equation

#include "CactusEinstein/ADMMacros/src/macro/DKDT_guts.h"

               adm_rhsK_metric_xx = DKDT_DKXXDT
               adm_rhsK_metric_xy = DKDT_DKXYDT
               adm_rhsK_metric_xz = DKDT_DKXZDT 
               adm_rhsK_metric_yy = DKDT_DKYYDT
               adm_rhsK_metric_yz = DKDT_DKYZDT
               adm_rhsK_metric_zz = DKDT_DKZZDT


c              Complete right-hand-side of K evolution equation

               adms_kxx(i,j,k) = adm_rhsK_metric_xx + adm_rhsK_matter_xx
               adms_kxy(i,j,k) = adm_rhsK_metric_xy + adm_rhsK_matter_xy
               adms_kxz(i,j,k) = adm_rhsK_metric_xz + adm_rhsK_matter_xz
               adms_kyy(i,j,k) = adm_rhsK_metric_yy + adm_rhsK_matter_yy 
               adms_kyz(i,j,k) = adm_rhsK_metric_yz + adm_rhsK_matter_yz
               adms_kzz(i,j,k) = adm_rhsK_metric_zz + adm_rhsK_matter_zz

#endif
