 /*@@
   @file      ParamCheck.c
   @date      Sat 4 May 2002
   @author    Gabrielle Allen
   @desc 
      Check parameters for EvolSimple
   @enddesc 
 @@*/

#include <stdio.h>
#include <stdlib.h>

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

static const char *rcsid = "$Header: /cactusdevcvs/CactusEinstein/EvolSimple/src/ParamCheck.c,v 1.2 2003/05/07 15:06:53 rideout Exp $";

CCTK_FILEVERSION(CactusEinstein_EvolSimple_ParamCheck_c);

void EvolSimple_ParamCheck(CCTK_ARGUMENTS);

 /*@@
   @routine    EvolSimple_ParamChecker
   @date       Sat 4 May 2002
   @author     Gabrielle Allen
   @desc 
      Check parameters for EvolSimple
   @enddesc 
   @calls     
   @history 
 
   @endhistory 
@@*/

void EvolSimple_ParamCheck(CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS;
  DECLARE_CCTK_PARAMETERS;

  if(! CCTK_EQUALS(metric_type, "physical"))
  {
    CCTK_PARAMWARN("Unknown ADMBase::metric_type - known types are \"physical\"");
  }

  if(! CCTK_EQUALS(initial_shift, "none"))
  {
    CCTK_PARAMWARN("Shift cannot be used with EvolSimple");
  }

  CCTK_INFO("Evolve using the Simple ADM system");
}
