 /*@@
   @file      ParamCheck.c
   @date      Mon April 29 2002
   @author    Gabrielle Allen
   @desc 
   Parameter checking stuff for Maximal
   @enddesc
   @version $Header: /cactusdevcvs/CactusEinstein/Maximal/src/ParamCheck.c,v 1.2 2002/05/02 21:54:51 allen Exp $
 @@*/

#include "cctk.h"

#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

static const char *rcsid = "$Header: /cactusdevcvs/CactusEinstein/Maximal/src/ParamCheck.c,v 1.2 2002/05/02 21:54:51 allen Exp $";

CCTK_FILEVERSION(CactusEinstein_Maximal_ParamCheck_c)

/********************************************************************
 *********************     Local Data Types   ***********************
 ********************************************************************/

/********************************************************************
 ********************* Local Routine Prototypes *********************
 ********************************************************************/

/********************************************************************
 ***************** Scheduled Routine Prototypes *********************
 ********************************************************************/

/********************************************************************
 ********************* Other Routine Prototypes *********************
 ********************************************************************/

/********************************************************************
 *********************     Local Data   *****************************
 ********************************************************************/

/********************************************************************
 *********************     External Routines   **********************
 ********************************************************************/

 /*@@
   @routine    Maximal_ParamCheck
   @date       Mon 29 April 2002
   @author     Gabrielle Allen
   @desc 
   Scheduled routine to detect invalid parameter settings.
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 
 
 @@*/
void Maximal_ParamCheck(CCTK_ARGUMENTS)
{
  DECLARE_CCTK_ARGUMENTS;
  DECLARE_CCTK_PARAMETERS;

  if(!CCTK_EQUALS(metric_type, "static conformal") && !CCTK_EQUALS(metric_type, "physical") )
  {
    CCTK_PARAMWARN("Unknown ADMBase::metric_type - known types are \"physical\" and \"static conformal\"");
  }
}

/********************************************************************
 *********************     Local Routines   *************************
 ********************************************************************/

