/*@@
   @file      Startup.c
   @date      
   @author    
   @desc
   Routines to run at startup time
   @enddesc
   @version   $Id: Startup.c,v 1.5 2002/01/04 09:19:29 allen Exp $
 @@*/

#include "cctk.h"
#include "cctk_Parameters.h"

#include "Slicing.h"

static const char *rcsid = "$Header: /cactusdevcvs/CactusEinstein/Maximal/src/Startup.c,v 1.5 2002/01/04 09:19:29 allen Exp $";

CCTK_FILEVERSION(CactusEinstein_Maximal_Startup_c)

/********************************************************************
 ********************    External Routines   ************************
 ********************************************************************/
void MaximalRegisterSlicing(void);


 /*@@
   @routine    MaximalRegisterSlicing
   @date       
   @author     
   @desc
   Scheduled routine to register maximal as a slicing condition
   with Einstein
   @enddesc

   @returntype int
   @returndesc

   @endreturndesc
@@*/
void MaximalRegisterSlicing(void) 
{
  DECLARE_CCTK_PARAMETERS

  int MaximalHelps(cGH *GH);
  int handle;

  /* Register maximal slicing */
  handle=Einstein_RegisterSlicing("maximal");

  /* Register the maxhelps TimeToSlice-Decision-Engine (TTSDE) */
  if (CCTK_Equals(maxhelps,"yes"))
  {
    Einstein_RegisterTimeToSlice(handle, MaximalHelps); 
  }
}  
