
$break = "\n     \$";

@xyz = ('x','y','z');
open (OUT, "> ../src/g2_derivs.inc");
print OUT <<EOH;
c DO NOT EDIT THIS FILE DIRECTLY! Rather edit adm_helper.pl which creates it
EOH

print OUT "        if (.false. .and. conformal_state .eq. CONFORMAL_METRIC_CONVERTED_TO_PHYSICAL) then \n";
print OUT "c Conformal second derivatives\n";
print OUT "c Non-mixed second derivatives\n";
$b = "     \$";
foreach $i (0..2) {
    $ijk = "(i,j,k)";
    if ($i == 0) {
	$plus = "(ip1,j,k)";
	$minus = "(im1,j,k)";
	$delta = "dx";
    }
    if ($i == 1) {
	$plus = "(i,jp1,k)";
	$minus = "(i,jm1,k)";
	$delta = "dy";
    }
    if ($i == 2) {
	$plus = "(i,j,kp1)";
	$minus = "(i,j,km1)";
	$delta = "dz";
    }

    foreach $j (0..2) {
	foreach $k ($j..2) {
	    $G = "g$xyz[$j]$xyz[$k]";
	    print OUT "          d2$xyz[$i]$xyz[$i]_$G = \n".
		"$b ($G$plus/(psi$plus**4) +\n".
		"$b $G$minus/(psi$minus**4) - \n".
		"$b  2.0D0*$G$ijk/(psi$ijk**4))/\n".
		"$b ($delta**2)\n";
	}
    }
}

print OUT "c Mixed second derivatives \n";
foreach $i (0..2) {
    if ($i == 0) {
	$which = "xy";
	$p1 = "(ip1,jp1,k)";
	$p2 = "(im1,jm1,k)";
	$m1 = "(im1,jp1,k)";
	$m2 = "(ip1,jm1,k)";
	$delta = "(4.0D0*dx*dy)";
    }
    if ($i == 1) {
	$which = "xz";
	$p1 = "(ip1,j,kp1)";
	$p2 = "(im1,j,km1)";
	$m1 = "(im1,j,kp1)";
	$m2 = "(ip1,j,km1)";
	$delta = "(4.0D0*dx*dz)";
    }
    if ($i == 2) {
	$which = "yz";
	$p1 = "(i,jp1,kp1)";
	$p2 = "(i,jm1,km1)";
	$m1 = "(i,jm1,kp1)";
	$m2 = "(i,jp1,km1)";
	$delta = "(4.0D0*dy*dz)";
    }
    foreach $j (0..2) {
	foreach $k ($j..2) {
	    $G = "g$xyz[$j]$xyz[$k]";
	    print OUT "          d2${which}_$G = ".
		"($G$p1/(psi$p1**4) + \n".
		"$b $G$p2/(psi$p2**4) - \n".
		    "$b  $G$m1/(psi$m1**4) - \n".
			"$b  $G$m2/(psi$m2**4))/\n".
		    "$b ($delta)\n";
	}
    }
}

print OUT "c Second Derivatives.\n";
print OUT "c dxy -> 12 g psia psib p4 + 4 p4 (g_a psi_b + g_b psi_a) + \n";
print OUT "c        4 p4 g psiab + p4 g_ab\n";
print OUT "c where g is the der with conformal in, and gam is conformal out\n";
print OUT "c Since we have conformal d's and g's here we have to re-work\n";
print OUT "c this a bit hence the .false. above...\n";

foreach $g (0..2) {
    foreach $i ($g..2) {
	foreach $j (0..2) {
	    foreach $k ($j..2) {
		$which = "d2$xyz[$g]$xyz[$i]";
		$G = "g$xyz[$j]$xyz[$k]";
		print OUT "        ${which}_$G = p4 * ( \n".
		    "$b    12.0D0 * $G(i,j,k) * psi$xyz[$g](i,j,k) * psi$xyz[$i](i,j,k) +\n".
		    "$b    4.0D0 * (d$xyz[$g]$G(i,j,k) * psi$xyz[$i](i,j,k) + \n".
	            "$b    d$xyz[$i]$G(i,j,k) * psi$xyz[$g](i,j,k)) + \n".
		    "$b    4.0D0 * $G(i,j,k) * psi$xyz[$g]$xyz[$i](i,j,k) + \n".
			"$b    ${which}_$G)\n";
	    }
	}
    }
}

print OUT "c END OF CONFORMAL DIFFERENCES\n";
print OUT "        else \n";
print OUT "c Standard Finite Difference the g's\n";

print OUT "c Non-mixed second derivatives\n";
foreach $i (0..2) {
    $ijk = "(i,j,k)";
    if ($i == 0) {
	$plus = "(ip1,j,k)";
	$minus = "(im1,j,k)";
	$delta = "dx";
    }
    if ($i == 1) {
	$plus = "(i,jp1,k)";
	$minus = "(i,jm1,k)";
	$delta = "dy";
    }
    if ($i == 2) {
	$plus = "(i,j,kp1)";
	$minus = "(i,j,km1)";
	$delta = "dz";
    }

    foreach $j (0..2) {
	foreach $k ($j..2) {
	    $G = "g$xyz[$j]$xyz[$k]";
	    print OUT "          d2$xyz[$i]$xyz[$i]_$G = ".
		"($G$plus + $G$minus - \n     \$  2.0D0*$G$ijk)/".
		    "($delta**2)\n";
	}
    }
}

print OUT "c Mixed second derivatives \n";
foreach $i (0..2) {
    if ($i == 0) {
	$which = "xy";
	$p1 = "(ip1,jp1,k)";
	$p2 = "(im1,jm1,k)";
	$m1 = "(im1,jp1,k)";
	$m2 = "(ip1,jm1,k)";
	$delta = "(4.0D0*dx*dy)";
    }
    if ($i == 1) {
	$which = "xz";
	$p1 = "(ip1,j,kp1)";
	$p2 = "(im1,j,km1)";
	$m1 = "(im1,j,kp1)";
	$m2 = "(ip1,j,km1)";
	$delta = "(4.0D0*dx*dz)";
    }
    if ($i == 2) {
	$which = "yz";
	$p1 = "(i,jp1,kp1)";
	$p2 = "(i,jm1,km1)";
	$m1 = "(i,jm1,kp1)";
	$m2 = "(i,jp1,km1)";
	$delta = "(4.0D0*dy*dz)";
    }
    foreach $j (0..2) {
	foreach $k ($j..2) {
	    $G = "g$xyz[$j]$xyz[$k]";
	    print OUT "          d2${which}_$G = ".
		"($G$p1 + $G$p2 - \n     \$  $G$m1 - $G$m2)/".
		    "($delta)\n";
	}
    }
}
print OUT "        endif\n";

close OUT;


