c/*@@
c  @file      PsiKadelia.F
c  @date      
c  @author    
c  @desc 
c  
c  @enddesc 
c@@*/

#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"
#include "PsiKadelia_constants.h"
#include "nPF_decl.h"

c/*@@
c  @routine    PsiKadelia
c  @date       
c  @author     
c  @desc 
c  
c  @enddesc 
c  @calls     
c  @calledby   
c  @history 
c
c  @endhistory 
c@@*/
#define jprint if(.false..and.i.eq.3.and.j.eq.3.and.k.eq.3)print
      subroutine PsiKadelia(CCTK_ARGUMENTS)
      implicit none
      DECLARE_CCTK_ARGUMENTS
      DECLARE_CCTK_PARAMETERS
      integer CCTK_Equals

      DECLARE_KG2_DER_POINT
      DECLARE_NAPSIFRIENDS

      CCTK_REAL one,two,p4,fac

      CCTK_REAL tmpxx,tmpyy,tmpzz

      integer i,j,k,im1,jm1,km1,ip1,jp1,kp1
      integer isf,jsf,ksf

      integer nx,ny,nz
      CCTK_REAL dx,dy,dz
      integer ones(3)
      integer ierr
      integer orig_conformal_state

c     define nx,ny,nz from cctk_lsh(DIM)
      nx=cctk_lsh(1)
      ny=cctk_lsh(2)
      nz=cctk_lsh(3)

      dx=cctk_delta_space(1)
      dy=cctk_delta_space(2)
      dz=cctk_delta_space(3)

      two = 2.0D0
      one = 1.0D0

      orig_conformal_state = conformal_state
      if (conformal_state .gt. 0) then

        do k=1,nz	
	  do j=1,ny
	    do i=1,nx
              gxx(i,j,k) = gxx(i,j,k)*psi(i,j,k)**4
	      gxy(i,j,k) = gxy(i,j,k)*psi(i,j,k)**4
	      gxz(i,j,k) = gxz(i,j,k)*psi(i,j,k)**4
	      gyy(i,j,k) = gyy(i,j,k)*psi(i,j,k)**4
	      gyz(i,j,k) = gyz(i,j,k)*psi(i,j,k)**4
	      gzz(i,j,k) = gzz(i,j,k)*psi(i,j,k)**4
            end do
	  end do
        end do
        conformal_state = 0

      endif      

      whichvec = 0
      if (CCTK_Equals(psif_vec,"radial").eq.1) then 
         whichvec = NEWAGEPSIFRIENDS_RADIAL_VEC
      endif
      if (CCTK_Equals(psif_vec,"cartesian").eq.1) then 
         whichvec = NEWAGEPSIFRIENDS_CARTESIAN_VEC
      endif
      if (CCTK_Equals(psif_vec,"metric_diag").eq.1) then 
         whichvec = NEWAGEPSIFRIENDS_METDIAG_VEC
      endif
      if (CCTK_Equals(psif_vec,"shock").eq.1) then 
         whichvec = NEWAGEPSIFRIENDS_SHOCK_VEC
      endif

c     We do not care about shift
      isf = 1
      jsf = 1
      ksf = 1

      do k=1,nz
         km1 = max(1,k-1)
         kp1 = min(nz,k+1)
         do j=1,ny
            jm1 = max(1,j-1)
            jp1 = min(ny,j+1)
            do i=1,nx
               im1 = max(1,i-1)
               ip1 = min(nx,i+1)
      jprint*,"phys_metric:psi,gxx,gxy,gxz,gyy,gyz,gzz\n"
     ~     ,psi(i,j,k),gxx(i,j,k),gxy(i,j,k),gxz(i,j,k),
     ~     gyy(i,j,k),gyz(i,j,k),gzz(i,j,k)


c     Find determinant.
               det= -(gxz(i,j,k)**2*gyy(i,j,k)) + 
     $              2*gxy(i,j,k)*gxz(i,j,k)*gyz(i,j,k) - 
     $              gxx(i,j,k)*gyz(i,j,k)**2  -
     $              gxy(i,j,k)**2*gzz(i,j,k) + 
     $              gxx(i,j,k)*gyy(i,j,k)*gzz(i,j,k)

      jprint*,"det: ",det

c     Invert metric. This is the conformal upper metric.
               uxx=(-gyz(i,j,k)**2 + gyy(i,j,k)*gzz(i,j,k))/det
               uxy=(gxz(i,j,k)*gyz(i,j,k) - gxy(i,j,k)*gzz(i,j,k))/det
               uyy=(-gxz(i,j,k)**2 + gxx(i,j,k)*gzz(i,j,k))/det
               uxz=(-gxz(i,j,k)*gyy(i,j,k) + gxy(i,j,k)*gyz(i,j,k))/det
               uyz=(gxy(i,j,k)*gxz(i,j,k) - gxx(i,j,k)*gyz(i,j,k))/det
               uzz=(-gxy(i,j,k)**2 + gxx(i,j,k)*gyy(i,j,k))/det
      jprint*,"inv_metric:gxx,gxy,gxz,gyy,gyz,gzz\n"
     ~     ,uxx,uxy,uxz,uyy,uyz,uzz

c     Form trK.
               trK =  (uxx*kxx(i,j,k)+
     $              uyy*kyy(i,j,k)+
     $              uzz*kzz(i,j,k)+
     $              two*uxy*kxy(i,j,k)+
     $              two*uxz*kxz(i,j,k)+
     $              two*uyz*kyz(i,j,k))

	jprint*,"trK: ",trK
C     Define local k,g variables to pass to subroutines
               kkxx=kxx(i,j,k)
               kkxy=kxy(i,j,k)
               kkxz=kxz(i,j,k)
               kkyy=kyy(i,j,k)
               kkyz=kyz(i,j,k)
               kkzz=kzz(i,j,k)
               ggxx=gxx(i,j,k)
               ggxy=gxy(i,j,k)
               ggxz=gxz(i,j,k)
               ggyy=gyy(i,j,k)
               ggyz=gyz(i,j,k)
               ggzz=gzz(i,j,k)
               xx=x(i,j,k)
               yy=y(i,j,k)
               zz=z(i,j,k)
               
        if( whichvec .ne. NEWAGEPSIFRIENDS_RADIAL_VEC.or.xx*yy.ne.0)then
c     Calculate only if not on the z-axis for the "radial" tetrad case

c     Form derivatives of K and G  and second derivatives of G.

#include "k_derivs.inc"

               if(orig_conformal_state .gt. 1) then
c     g_conf_derivs.inc uses only the first derivatives of psi

#include "g_conf_derivs.inc"

               else

#include "g_derivs.inc"

               endif

#include "g2_derivs.inc"

      jprint*,"kxderivs: ",dxkxx,dxkxy,dxkxz,dxkyy,dxkyz,dxkzz
      jprint*,"kyderivs: ",dykxx,dykxy,dykxz,dykyy,dykyz,dykzz
      jprint*,"kzderivs: ",dzkxx,dzkxy,dzkxz,dzkyy,dzkyz,dzkzz
      jprint*,"gxderivs: ",dxgxx,dxgxy,dxgxz,dxgyy,dxgyz,dxgzz
      jprint*,"gyderivs: ",dygxx,dygxy,dygxz,dygyy,dygyz,dygzz
      jprint*,"gzderivs: ",dzgxx,dzgxy,dzgxz,dzgyy,dzgyz,dzgzz
      jprint*,"d2xx: ",d2xx_gxx,d2xx_gxy,d2xx_gxz,
     ~     d2xx_gyy,d2xx_gyz,d2xx_gzz
      jprint*,"d2xy: ",d2xy_gxx,d2xy_gxy,d2xy_gxz,
     ~     d2xy_gyy,d2xy_gyz,d2xy_gzz
      jprint*,"d2xz: ",d2xz_gxx,d2xz_gxy,d2xz_gxz,
     ~     d2xz_gyy,d2xz_gyz,d2xz_gzz
      jprint*,"d2yy: ",d2yy_gxx,d2yy_gxy,d2yy_gxz,
     ~     d2yy_gyy,d2yy_gyz,d2yy_gzz
      jprint*,"d2yz: ",d2yz_gxx,d2yz_gxy,d2yz_gxz,
     ~     d2yz_gyy,d2yz_gyz,d2yz_gzz
      jprint*,"d2zz: ",d2zz_gxx,d2zz_gxy,d2zz_gxz,
     ~     d2zz_gyy,d2zz_gyz,d2zz_gzz


     

c     Form covariant derivatives of K
               call nPF_cds(KG2_DER_POINT,NAPSIFRIENDS)

c     Orthogonalize the vectors
               call nPF_vecs(KG2_DER_POINT,NAPSIFRIENDS)

c     Form the Ricci Tensor
               call RicciPoint(KG2_DER_POINT,NAPSIFRIENDS)

#if 0
               tmpxx = 4.0D0 * (2.0D0*x(i,j,k)**2 - y(i,j,k)**2 -
     $              z(i,j,k)**2)/((2.0D0 * r(i,j,k) + 1.0D0)**2 * 
     $              r(i,j,k)**3)
               tmpyy = 4.0D0 * (-x(i,j,k)**2 + 2.0D0* y(i,j,k)**2 -
     $              z(i,j,k)**2)/((2.0D0 * r(i,j,k) + 1.0D0)**2 * 
     $              r(i,j,k)**3)
               tmpzz = 4.0D0 * (-x(i,j,k)**2 - y(i,j,k)**2 +2.0D0*
     $              z(i,j,k)**2)/((2.0D0 * r(i,j,k) + 1.0D0)**2 * 
     $              r(i,j,k)**3)
c               print *,ricxx_loc/tmpxx,ricyy_loc/tmpyy,riczz_loc/tmpzz

c     yy -> psi, zz-> psi,x,x
               tmpyy = 1 + 0.5D0/r(i,j,k)
               tmpzz = 1.5 * x(i,j,k)**2 / r(i,j,k)**5 -
     $              0.5D0 / r(i,j,k)**3

               tmpxx = 4.0D0 * tmpyy**3 * -0.5 * x(i,j,k) / r(i,j,k)**3 +
     $              12.0D0 * tmpyy**2 * tmpzz**2
c               print *,d2xx_gxx/tmpxx,gxx(i,j,k)/(1 + 0.5D0/r(i,j,k))**4
#endif

c     And calculate
               call PsiFriends(KG2_DER_POINT,NAPSIFRIENDS)


c     If required scale by radial coordinate
	          if (scale_with_radius == 1) then
			fac = r(i,j,k)**radius_power
	          else
			fac = 1.0
		  end if

c     Now copy out
c     Riccis
                  ricscal(i,j,k) = fac*ricscal_loc

                  ricxx(i,j,k) = fac*ricxx_loc
                  ricxy(i,j,k) = fac*ricxy_loc
                  ricxz(i,j,k) = fac*ricxz_loc
                  ricyy(i,j,k) = fac*ricyy_loc
                  ricyz(i,j,k) = fac*ricyz_loc
                  riczz(i,j,k) = fac*riczz_loc


c     Psis we do pairwise
                  psi0re(i,j,k) = fac*psi0re_loc
                  psi0im(i,j,k) = fac*psi0im_loc
                  psi1re(i,j,k) = fac*psi1re_loc
                  psi1im(i,j,k) = fac*psi1im_loc
                  psi2re(i,j,k) = fac*psi2re_loc
                  psi2im(i,j,k) = fac*psi2im_loc
                  psi3re(i,j,k) = fac*psi3re_loc
                  psi3im(i,j,k) = fac*psi3im_loc
                  psi4re(i,j,k) = fac*psi4re_loc
                  psi4im(i,j,k) = fac*psi4im_loc

c     Invariants
                  icurvre(i,j,k) = fac*icurvre_loc
                  icurvim(i,j,k) = fac*icurvim_loc
                  jcurvre(i,j,k) = fac*jcurvre_loc
                  jcurvim(i,j,k) = fac*jcurvim_loc

               else 
c  Set values to zero without calculating on the z-axis
                  ricscal(i,j,k) = 0

                  ricxx(i,j,k) = 0 
                  ricxy(i,j,k) = 0
                  ricxz(i,j,k) = 0
                  ricyy(i,j,k) = 0
                  ricyz(i,j,k) = 0
                  riczz(i,j,k) = 0


c     Psis we do pairwise
                  psi0re(i,j,k) = 0
                  psi0im(i,j,k) = 0
                  psi1re(i,j,k) = 0
                  psi1im(i,j,k) = 0
                  psi2re(i,j,k) = 0
                  psi2im(i,j,k) = 0
                  psi3re(i,j,k) = 0
                  psi3im(i,j,k) = 0
                  psi4re(i,j,k) = 0
                  psi4im(i,j,k) = 0

c     Invariants
                  icurvre(i,j,k) = 0
                  icurvim(i,j,k) = 0
                  jcurvre(i,j,k) = 0
                  jcurvim(i,j,k) = 0
               endif

            enddo
         enddo
      enddo

	

      ones(1) = 1
      ones(2) = 1
      ones(3) = 1

      call CartSymGN(ierr,cctkGH,'PsiKadelia::RicciScalar')
      call BndFlatGN(ierr,cctkGH,ones,'PsiKadelia::RicciScalar')

      call CartSymGN(ierr,cctkGH,'PsiKadelia::RicciComponents')
      call BndFlatGN(ierr,cctkGH,ones,'PsiKadelia::RicciComponents')

      call CartSymGN(ierr,cctkGH,'PsiKadelia::WeylComponents')
      call BndFlatGN(ierr,cctkGH,ones,'PsiKadelia::WeylComponents')

      call CartSymGN(ierr,cctkGH,'PsiKadelia::IJinvariants')
      call BndFlatGN(ierr,cctkGH,ones,'PsiKadelia::IJinvariants')



c---- Hisaaki added 19980429
      if (CCTK_Equals(pnd_routine,"yes").eq.1) then 
         call pnd(CCTK_ARGUMENTS,whichvec)
      endif
c----

      if (orig_conformal_state .gt. 0) then

        do k=1,nz
	  do j=1,ny
	    do i=1,nx
              gxx(i,j,k) = gxx(i,j,k)/psi(i,j,k)**4
	      gxy(i,j,k) = gxy(i,j,k)/psi(i,j,k)**4
	      gxz(i,j,k) = gxz(i,j,k)/psi(i,j,k)**4
	      gyy(i,j,k) = gyy(i,j,k)/psi(i,j,k)**4
	      gyz(i,j,k) = gyz(i,j,k)/psi(i,j,k)**4
	      gzz(i,j,k) = gzz(i,j,k)/psi(i,j,k)**4
            end do
	  end do
        end do
        conformal_state = orig_conformal_state
      
      end if

      return
      end
