#include "include/PsiKadelia_constants.h"
#include "include/nPF_decl.h"

#include "cctk_Parameters.h"

      subroutine nPF_Vecs(KG2_DER_POINT, NAPSIFRIENDS)
      implicit none
      DECLARE_KG2_DER_POINT
      DECLARE_NAPSIFRIENDS
      DECLARE_CCTK_PARAMETERS

      CCTK_REAL o1,o2,o3,o4,o5,o6,o7,o8,o9
      CCTK_REAL o10,o11,o12,o13,o14,o15,o16,o17,o18
      CCTK_REAL o19,o20,o21,o22,o23,o24,o25,o26,o27
      CCTK_REAL o28,o29

     

c From brandt@aei-potsdam.mpg.de Thu May 28 09:31:22 1998
c To: Hisaaki Shinkai <shinkai@wurel.wustl.edu>
c
c There are three vectors, v1, v2, v3.  Each has an x, y, and z
c component.  However, the epsilon gives you v3 once you have v1
c and v2, so you don not need to supply it.  To get basis vectors
c aligned with the x, y, and z directions you could set v1x = 1,
c v1y = v1z = 0, v2x = v2z = 0, v2y = 1.  To get spherical basis
c vectors one needs v1x = x, v1y = y, v1z = z, v2x = -y, v2y = x, 
c v2z = 0. Or something like that.  This gives an r and a phi basis 
c vector (I believe it is the default -- the problem you had occurs 
c when x = y = z = 0.0).

c Intiialize vector 
c      "psif_vec" contains "radial", or as a default
      if(whichvec.eq.NEWAGEPSIFRIENDS_RADIAL_VEC)then


c        Note to Steve:  These vectors are orthogonal, but are
c        not normalized to 1.  Should they be?  Also, the vectors
c        vanish at the origin and this will produce NaNs. Maybe
c        a warning is in order if someone choses this option.  Miguel.

         v1x = xx
         v1y = yy
         v1z = zz

         v2x = -yy
         v2y = xx
         v2z = 0.0D0

      else if(whichvec.eq.NEWAGEPSIFRIENDS_CARTESIAN_VEC)then

c      "psif_vec" contains "cartesian"

c        Note to Steve:  Here I changed the original expressions to make
c        the vectors orthonormal and avoid NaNs along the axis.  Miguel.
c        write(*,*) "which=2 in pnd_nPF"

         v1x = 1.0D0
         v1y = 0.0D0
         v1z = 0.0D0

         v2x = 0.0D0
         v2y = 1.0D0
         v2z = 0.0D0

      else if(whichvec.eq.NEWAGEPSIFRIENDS_METDIAG_VEC)then

c 980611 9806018
         v1x = 0.0d0
         v1y = 0.0D0
         v1z = 1.0D0/sqrt(ggzz)
         v2x = 1.0D0/sqrt(ggxx)
         v2y = 0.0d0
         v2z = 0.0D0

      else if(whichvec.eq.NEWAGEPSIFRIENDS_SHOCK_VEC)then
         v1x = 1.0D0/sqrt(ggxx)
         v1y = 0.0D0
         v1z = 0.0D0
         v2x = 0.0D0
         v2y = 1.0D0/sqrt(ggyy)
         v2z = 0.0D0

      else

         call CCTK_WARN(1,"Psi Vector Choice improper")

      endif

#include "set_basis_vectors.x"

      return
      end
