c=======================================================================
c-----------------------------------------------------------------------
c Principal Null Directions : compute and output in thorn_PsiKadelia
c     by Hisaaki Shinkai, shinkai@wurel.wustl.edu
c                            
c-----------------------------------------------------------------------
c  CACTUS version: file name      = pnd.F   
c                  thorn_pninit   = version 1.0    19990618
c                  thorn_pninit   = version 1.1    19991106
c                  to be called   = PsiKadelia.F77
c                  to call subs   = pnd_sub.F pnd_nPF_vecs.F
c
c  note that all variables are not double precision
c
c-----------------------------------------------------------------------
#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"

      subroutine pnd(CCTK_ARGUMENTS,whichvec)

      implicit NONE
      DECLARE_CCTK_ARGUMENTS
      DECLARE_CCTK_PARAMETERS
      integer CCTK_Equals
      
c input output
      integer  whichvec
c locally defined
      character(len=30) head_title, second_title
      character(len=2)  time_stamp
      integer  it_pnd
      integer  it_stock(100)
      CCTK_REAL     pnd_time(100)

      CCTK_REAL     pi

      integer  i,j,k,iflag

      integer  mpro,marrow
      integer  jx,ixfrom,ixto,ixstep,midx
      integer  jy,iyfrom,iyto,iystep,midy
      integer  jz,izfrom,izto,izstep,midz
      CCTK_REAL     xcord,ycord,zcord,yaji
      CCTK_REAL     pnd1t,pnd2t,pnd3t,pnd4t,pnd1x,pnd2x,pnd3x,pnd4x
      CCTK_REAL     pnd1y,pnd2y,pnd3y,pnd4y,pnd1z,pnd2z,pnd3z,pnd4z

      complex  ps0,ps1,ps2,ps3,ps4   
      complex  pndPSI,pndPSJ,pndPSH,pndPSG
      complex  tinyc,zeroc
      CCTK_REAL     z1r,z1i,z2r,z2i,z3r,z3i,z4r,z4i,zan1,zan2,zan3,zan4
      CCTK_REAL     zr1,zr2,zr3,zr4,zrsr1,zrsr2,zrsr3,zrsr4,zang
      CCTK_REAL     arrow_length,tinyR,tinycut
      CCTK_REAL     OX1,OX2,OX3,OY1,OY2,OY3,OZ1,OZ2,OZ3
c locally defined for PND output (candidate for small GridFunc)
      integer mx,my,mz,mjx,mjy,mjz
      parameter(mx=11,my=11,mz=11)
      CCTK_REAL      pnvec1x(mx,my,mz),pnvec1y(mx,my,mz),pnvec1z(mx,my,mz)
      CCTK_REAL      pnvec2x(mx,my,mz),pnvec2y(mx,my,mz),pnvec2z(mx,my,mz)
      CCTK_REAL      pnvec3x(mx,my,mz),pnvec3y(mx,my,mz),pnvec3z(mx,my,mz)
      CCTK_REAL      pnvec4x(mx,my,mz),pnvec4y(mx,my,mz),pnvec4z(mx,my,mz)
      integer off_multifiles

c locally defined for Petrov type
      character(len=6) PETROV
      integer  npetrov,petrov_dim,i_firsttime,i_lasttime

      integer nx,ny,nz

      pi = ACOS(-1D0)

c     define nx,ny,nz from cctk_lsh(DIM)

      nx=cctk_lsh(1)
      ny=cctk_lsh(2)
      nz=cctk_lsh(3)


      write(*,*) ' welcome to pnd.F:  19980619 version by Hisaaki'
      zeroc=cmplx(0.0,0.0)
      tinyc=cmplx(1.0e-15,1.0e-15)
      tinyR=1.0e-8
      tinycut=pnd_tinycut

      off_multifiles=0   ! 1 on / 0 off
c-----------------------------------------------------------------------
c required parameters for this pnd.F
c-----------------------------------------------------------------------
c  mpro=  Projection on XY(1) or XZ(2)
      mpro=0
      if(CCTK_Equals(pnd_project,"xy").eq.1) mpro=1
      if(CCTK_Equals(pnd_project,"xz").eq.1) mpro=2
      if(CCTK_Equals(pnd_project,"yz").eq.1) mpro=3
      if(CCTK_Equals(pnd_project,"all").eq.1) mpro=4
c  marrow= # of arrows on one direction
      marrow = pnd_arrownum
      if(marrow.gt.min(mx,my,mz)) then
         write(*,*) ' output grid number pnd_arrownum is greater than'
         write(*,*) ' the prepared arrays.   '
         write(*,*) ' try smaller pnd_arrownum or change mx,my,mz in '
         write(*,*) ' thorn_PsiKadelia/src/pnd.F '
      endif
c  yaji= arrow length
      arrow_length = pnd_arrowlength
      yaji=(x(int(nx/marrow),ny/2,nz/2)-x(1,ny/2,nz/2))*arrow_length
c
      if(mpro.eq.1) write(*,*) '    pnd_project    =    (xy)   plane'
      if(mpro.eq.2) write(*,*) '    pnd_project    =    (xz)   plane'
      if(mpro.eq.3) write(*,*) '    pnd_project    =    (yz)   plane'
      write(*,*) '    pnd_arrownum   =',marrow
      write(*,*) '    pnd_arrowlength=',arrow_length
c-----------------------------------------------------------------------
c open files with time stamp     file names =  pnd1.t=xx
c                                              pnd2.t=xx etc
c-----------------------------------------------------------------------
      if(CCTK_Equals(pnd_output,"yes").eq.1) then
      open(90,file='pnd.time')
      read(90,3000,end=1,err=1) head_title
 3000 format (a30) 
      goto 2
c------------- first time to come this subroutine, welcome
    1 continue
        time_stamp='00'
        pnd_time(1)=CCTK_time
        it_stock(1)=0
        it_pnd=1
      goto 3
c------------- repeater of this subroutine, welcome
    2 continue
c3001   format(3x,i3) 
c$$$    read(90,3001) it_pnd
c$$$    read(90,3000) second_title
        read(90,'(i3)') it_pnd
        read(90,'(a30)') second_title
           do i=1,it_pnd
c 3002        format(3x,i5,f15.2)
c$$$          read(90,3002) it_stock(i),pnd_time(i)
              read(90,'(i5,f15.2)') it_stock(i),pnd_time(i)
        enddo

        call pnd_stamp(it_pnd,time_stamp)

        it_pnd=it_pnd+1
        it_stock(it_pnd)=it_stock(it_pnd-1)+1
        pnd_time(it_pnd)=CCTK_time

c------------- altogether
    3 continue
      close(90)
c------------- for the next visit
      open(90,file='pnd.time')
c$$$     write(90,3100) '-- pnd printout time stamp --'
c$$$     write(90,3101) it_pnd
c$$$     write(90,3100) 'stamp        time            '
         write(90,'(a30)') '-- pnd printout time stamp --'
         write(90,'(i3)') it_pnd
         write(90,'(a30)') 'stamp        time            '
         do i=1,it_pnd
            write(90,'(i5,f15.2)') it_stock(i),pnd_time(i)
         enddo
c 3100       format(1h ,a30)
c 3101       format(1h ,i3)
c 3103       format(1h ,i5,f15.2)
      close(90)
c--------------
        open(20,file='petrov.t='//time_stamp,status='unknown')
        open(99,file='pnd.t='//time_stamp,status='unknown')
        if(off_multifiles.eq.1) then
        open(91,file='pnd1.t='//time_stamp,status='unknown')
        open(92,file='pnd2.t='//time_stamp,status='unknown')
        open(93,file='pnd3.t='//time_stamp,status='unknown')
        open(94,file='pnd4.t='//time_stamp,status='unknown')
        endif
      endif
c-----------------------------------------------------------------------
c
c  pnd/Petrov routine 
c
c-----------------------------------------------------------------------
c  mpro=  Projection on XY(1) or XZ(2) or YZ(3) or all(4)
c$$$         midx=int(((xmax+xmin)/2.0-xmin)/dx)+1
c$$$         midy=int(((ymax+ymin)/2.0-ymin)/dy)+1
c$$$         midz=int(((zmax+zmin)/2.0-zmin)/dz)+1
         midx=int(((x(1,1,1)+x(nx,1,1))/2.0-x(1,1,1))/cctk_delta_space(1))+1
         midy=int(((y(1,1,1)+y(1,ny,1))/2.0-y(1,1,1))/cctk_delta_space(2))+1
         midz=int(((z(1,1,1)+z(1,1,nz))/2.0-z(1,1,1))/cctk_delta_space(3))+1
c         write(*,*) 'midx,midy,midz=',midx,midy,midz

      if(mpro.eq.1) then
         ixfrom=1
         ixto  =nx
         ixstep=nint(real(nx)/real(marrow))
         iyfrom=1
         iyto  =ny
         iystep=nint(real(ny)/real(marrow))
         izfrom=midz
         izto  =midz
         izstep=1
      elseif(mpro.eq.2) then
         ixfrom=1
         ixto  =nx
         ixstep=nint(real(nx)/real(marrow))
         iyfrom=midy
         iyto  =midy
         iystep=1
         izfrom=1
         izto  =nz
         izstep=nint(real(nz)/real(marrow))
      elseif(mpro.eq.3) then
         ixfrom=midx
         ixto  =midx
         ixstep=1
         iyfrom=1
         iyto  =ny
         iystep=nint(real(ny)/real(marrow))
         izfrom=1
         izto  =nz
         izstep=nint(real(nz)/real(marrow))
      elseif(mpro.eq.4) then
         ixfrom=1
         ixto  =nx
         ixstep=nint(real(nx)/real(marrow))
         iyfrom=1
         iyto  =ny
         iystep=nint(real(ny)/real(marrow))
         izfrom=1
         izto  =nz
         izstep=nint(real(nz)/real(marrow))
      else 
         write(*,*) ' wrong mpro is selected : pnd.F/thorn_PsiKadelia'
         stop
      endif

      petrov_dim=petrov_output_dim

c--------------------------------------------------------->>>>>>>>>>>>>
c--------------------------------------------------------->>>>>>>>>>>>>
      do 1200 jz=izfrom,izto,izstep
      do 1100 jy=iyfrom,iyto,iystep
      do 1000 jx=ixfrom,ixto,ixstep
          mjx=ixfrom+(jx-ixfrom)/ixstep
          mjy=iyfrom+(jy-iyfrom)/iystep
          mjz=izfrom+(jz-izfrom)/izstep

            i_firsttime=0
         if(jx.eq.ixfrom.AND.jy.eq.iyfrom.AND.jz.eq.izfrom) 
     &      i_firsttime=1
            i_lasttime=0
         if(jx.eq.ixto.AND.jy.eq.iyto.AND.jz.eq.izto) 
     &      i_lasttime=1
         
            xcord=real(x(jx,jy,jz))
            ycord=real(y(jx,jy,jz))
            zcord=real(z(jx,jy,jz))
c          write(*,*) xcord,ycord,zcord

         ps0=cmplx(real(psi0re(jx,jy,jz)),real(psi0im(jx,jy,jz)))
         ps1=cmplx(real(psi1re(jx,jy,jz)),real(psi1im(jx,jy,jz)))
         ps2=cmplx(real(psi2re(jx,jy,jz)),real(psi2im(jx,jy,jz)))
         ps3=cmplx(real(psi3re(jx,jy,jz)),real(psi3im(jx,jy,jz)))
         ps4=cmplx(real(psi4re(jx,jy,jz)),real(psi4im(jx,jy,jz)))
c cut off small numbers
      call check_tinyc(ps0,tinycut)
      call check_tinyc(ps1,tinycut)
      call check_tinyc(ps2,tinycut)
      call check_tinyc(ps3,tinycut)
      call check_tinyc(ps4,tinycut)

c#######################################################################
c local Petrov type output 
c#######################################################################
      if(CCTK_Equals(pnd_output,"yes").eq.1) then

      call petrov_judge(ps0,ps1,ps2,ps3,ps4,petrov_eps,npetrov,PETROV)

c Petrov type output --------------------------------------------------
c      call petrov_output_interface(i_firsttime,i_lasttime,nx,ny,nz,
c     &                         midx,midy,midz,dx,dy,dz
c     &                         npetrov, xcord,ycord,zcord, petrov_dim)

      if(i_firsttime.eq.1) then
         write(20,*) '(* This output is for Mathematica *)'
         write(20,*) '(* You only need to type "<< filename" *)'
         write(20,*) '(*     HShinkai : shinkai@wurel.wustl.edu *)'
         write(20,*) '(*     19980618 version  *)'
         write(20,*) '<< Graphics`Graphics`'
         write(20,*) 'petrovlist=List['
      endif

c-----
      call petrov_output_f90(npetrov, xcord,ycord,zcord, petrov_dim)
c-----
      if(i_lasttime.eq.0) write(20,*) ','
      if(i_lasttime.eq.1) write(20,*) ']'
      if((i_lasttime.eq.1).AND.(petrov_dim.eq.3)) then
c        write(20,*) '(* This is an option  '
         write(20,*) 'graph=Graphics3D[petrovlist]'

         write(20,'("labelxyz=List[ Text[x,{",f12.3,",",f12.3,",",f12.3,"}],")') 
     &         x(midx,midy,midz),y(midx,1,midz)-cctk_delta_space(2),z(midx,midy,midz) 
         write(20,'("Text[y,{",f12.3,",",f12.3,",",f12.3,"}],")')
     &         x(1,midy,midz)-cctk_delta_space(1),y(midx,midy,midz),z(midx,midy,midz) 
         write(20,'("Text[z,{",f12.3,",",f12.3,",",f12.3,"}]]")')
     &         x(1,midy,midz)-cctk_delta_space(1),y(midx,1,midz)-cctk_delta_space(2),z(midx,midy,midz) 
         write(20,*) 'graph2=Graphics3D[labelxyz]'

         write(20,*) 'Show[graph, graph2, '
         write(20,'("PlotRange -> {{",f12.3,",",f12.3,"},{",f12.3,",",f12.3,"},{",f12.3,",",f12.3,"}},")')
     &                 x(1,midy,midz),x(nx,midy,midz),
     &                 y(midx,1,midz),y(midx,ny,midz),
     &                 z(midx,midy,1),z(midx,midy,nz)
         write(20,*) 'BoxRatios -> {1,1,1}]'
c        write(20,*) ' *) '
      endif
      if((i_lasttime.eq.1).AND.(petrov_dim.eq.2)) then
c        write(20,*) '(* This is an option  '
         write(20,*) 'Show[Graphics[petrovlist], PlotRange -> All,'
         write(20,*) 'Frame -> True,AspectRatio -> 1]'
c        write(20,*) ' *) '
      endif


      endif
c############################################################ index 15 #
c  part 15.   Solution of eq. ps4*z^4+4*ps3*z^3+6*ps2*z^2+4*ps1*z+ps0=0
c#######################################################################
c common to stand-alone and cactus version

      call pnd_solve_quartic(ps0,ps1,ps2,ps3,ps4,zeroc,tinyc,pi,
     &                       z1r,z2r,z3r,z4r,z1i,z2i,z3i,z4i,iflag)
c      write(*,*) ' solve_quartic -> pnd'
      
c      write(*,'("z1,z2= ",6e12.3)') z1r,z1i,z2r,z2i

c############################################################ index 17 #
c  part 17.   Principal Null Direction
c#######################################################################
c common to stand-alone and cactus version

      call zi2pnd(z1r,z1i,z2r,z2i,z3r,z3i,z4r,z4i,iflag,
     &            pnd1t,pnd1x,pnd1y,pnd1z,pnd2t,pnd2x,pnd2y,pnd2z,
     &            pnd3t,pnd3x,pnd3y,pnd3z,pnd4t,pnd4x,pnd4y,pnd4z)
c      write(*,*) ' zi2pnd -> pnd'

c############################################################ index 18 #
c  part 18.   PN vector in BASIS Component 
c#######################################################################
c only for cactus version

      call pnd_nPF_Vecs(xcord,ycord,zcord,whichvec,
     &  real(gxx(jx,jy,jz)),real(gyy(jx,jy,jz)),real(gzz(jx,jy,jz)),
     &  real(gxz(jx,jy,jz)),real(gxz(jx,jy,jz)),real(gyz(jx,jy,jz)),
     &  OZ1,OZ2,OZ3,OX1,OX2,OX3,OY1,OY2,OY3)
c     &  OX1,OX2,OX3,OY1,OY2,OY3,OZ1,OZ2,OZ3)

c      write(*,*) ' pnd_nPF_vecs -> pnd'
c OX(1,2,3) ... x^a  ... v2
c OY(1,2,3) ... y^a  ... v3
c OZ(1,2,3) ... z^a  ... v1

c$$$      write(*,'("base1= ",6e12.3)') OX1,OX2,OX3
c$$$      write(*,'("base2= ",6e12.3)') OY1,OY2,OY3
c$$$      write(*,'("base3= ",6e12.3)') OZ1,OZ2,OZ3


c common to stand-alone and cactus version
      call tetrad_express(pnd1x,pnd1y,pnd1z,pnd2x,pnd2y,pnd2z,
     &                    pnd3x,pnd3y,pnd3z,pnd4x,pnd4y,pnd4z,
     &                    OX1,OX2,OX3,OY1,OY2,OY3,OZ1,OZ2,OZ3)
                                    
      write(*,*) ' tetrad_express -> pnd'
c      write(*,'(4e12.3)') pnd1x,pnd1y,pnd2x,pnd2y

c-----------------------------------------------------------------------
c common to stand-alone and cactus version
      if(off_multifiles.eq.1) then
         if(CCTK_Equals(pnd_output,"yes").eq.1) then
c----- on XY plane
            if(mpro.eq.1) then 
               call output_pnd_math(xcord,ycord,pnd1x,pnd1y,pnd2x,pnd2y,
     &              pnd3x,pnd3y,pnd4x,pnd4y,yaji,tinyR)
c----- on XZ plane
            elseif(mpro.eq.2) then
               call output_pnd_math(xcord,zcord,pnd1x,pnd1z,pnd2x,pnd2z,
     &              pnd3x,pnd3z,pnd4x,pnd4z,yaji,tinyR)
c----- on YZ plane
            elseif(mpro.eq.3) then
               call output_pnd_math(ycord,zcord,pnd1y,pnd1z,pnd2y,pnd2z,
     &              pnd3y,pnd3z,pnd4y,pnd4z,yaji,tinyR)
            endif
         endif
      endif
c      write(*,*) ' output -> pnd'
c-----------------------------------------------------------------------
c stock pnd data in 3D array
c$$$      call pnd2gridfunc(mjx,mjy,mjz,mx,my,mz,pnd1x,pnd1y,pnd1z,
c$$$     &                              pnvec1x,pnvec1y,pnvec1z)
c$$$      call pnd2gridfunc(mjx,mjy,mjz,mx,my,mz,pnd2x,pnd2y,pnd2z,
c$$$     &                              pnvec2x,pnvec2y,pnvec2z)
c$$$      call pnd2gridfunc(mjx,mjy,mjz,mx,my,mz,pnd3x,pnd3y,pnd3z,
c$$$     &                              pnvec3x,pnvec3y,pnvec3z)
c$$$      call pnd2gridfunc(mjx,mjy,mjz,mx,my,mz,pnd4x,pnd4y,pnd4z,
c$$$     &                              pnvec4x,pnvec4y,pnvec4z)
      pnvec1x(mjx,mjy,mjz)=pnd1x
      pnvec1y(mjx,mjy,mjz)=pnd1y
      pnvec1z(mjx,mjy,mjz)=pnd1z
      pnvec2x(mjx,mjy,mjz)=pnd2x
      pnvec2y(mjx,mjy,mjz)=pnd2y
      pnvec2z(mjx,mjy,mjz)=pnd2z
      pnvec3x(mjx,mjy,mjz)=pnd3x
      pnvec3y(mjx,mjy,mjz)=pnd3y
      pnvec3z(mjx,mjy,mjz)=pnd3z
      pnvec4x(mjx,mjy,mjz)=pnd4x
      pnvec4y(mjx,mjy,mjz)=pnd4y
      pnvec4z(mjx,mjy,mjz)=pnd4z

 1000 continue
 1100 continue
 1200 continue
c---------------------------------------------------------<<<<<<<<<<<<<
c---------------------------------------------------------<<<<<<<<<<<<<
c prepare pnd data file in one big file with Mathematica format
c      write(*,*) shape(pnvec1x),shape(x)

      write(*,*) 'pnd -> printpnd '
      if(CCTK_Equals(pnd_output,"yes").eq.1) then
         call printpnd_in1_cactus(CCTK_ARGUMENTS,mpro,mx,my,mz,
     &        ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &        yaji,tinyR,
     &        pnvec1x,pnvec1y,pnvec1z,
     &        pnvec2x,pnvec2y,pnvec2z,
     &        pnvec3x,pnvec3y,pnvec3z,
     &        pnvec4x,pnvec4y,pnvec4z)
      endif
      
      write(*,*) 'printpnd -> pnd'

c-----------------------------------------------------------------------
c close files
c-----------------------------------------------------------------------
      if(CCTK_Equals(pnd_output,"yes").eq.1) then
         close(20)
        if(off_multifiles.eq.1) then
         close(91)
         close(92)
         close(93)
         close(94)
        endif
         close(99)
      endif

      end
c=======================================================================
c=======================================================================
      subroutine pnd_stamp(it_pnd,time_stamp)
      integer it_pnd
      character(len=2) time_stamp

        if(it_pnd.eq.1)  time_stamp='01'
        if(it_pnd.eq.2)  time_stamp='02'
        if(it_pnd.eq.3)  time_stamp='03'
        if(it_pnd.eq.4)  time_stamp='04'
        if(it_pnd.eq.5)  time_stamp='05'
        if(it_pnd.eq.6)  time_stamp='06'
        if(it_pnd.eq.7)  time_stamp='07'
        if(it_pnd.eq.8)  time_stamp='08'
        if(it_pnd.eq.9)  time_stamp='09'
        if(it_pnd.eq.10) time_stamp='10'
        if(it_pnd.eq.11) time_stamp='11'
        if(it_pnd.eq.12) time_stamp='12'
        if(it_pnd.eq.13) time_stamp='13'
        if(it_pnd.eq.14) time_stamp='14'
        if(it_pnd.eq.15) time_stamp='15'
        if(it_pnd.eq.16) time_stamp='16'
        if(it_pnd.eq.17) time_stamp='17'
        if(it_pnd.eq.18) time_stamp='18'
        if(it_pnd.eq.19) time_stamp='19'
        if(it_pnd.eq.20) time_stamp='20'
        if(it_pnd.eq.21) time_stamp='21'
        if(it_pnd.eq.22) time_stamp='22'
        if(it_pnd.eq.23) time_stamp='23'
        if(it_pnd.eq.24) time_stamp='24'
        if(it_pnd.eq.25) time_stamp='25'
        if(it_pnd.eq.26) time_stamp='26'
        if(it_pnd.eq.27) time_stamp='27'
        if(it_pnd.eq.28) time_stamp='28'
        if(it_pnd.eq.29) time_stamp='29'
        if(it_pnd.eq.30) time_stamp='30'
        if(it_pnd.eq.31) time_stamp='31'
        if(it_pnd.eq.32) time_stamp='32'
        if(it_pnd.eq.33) time_stamp='33'
        if(it_pnd.eq.34) time_stamp='34'
        if(it_pnd.eq.35) time_stamp='35'
        if(it_pnd.eq.36) time_stamp='36'
        if(it_pnd.eq.37) time_stamp='37'
        if(it_pnd.eq.38) time_stamp='38'
        if(it_pnd.eq.39) time_stamp='39'
        if(it_pnd.eq.40) time_stamp='40'
        if(it_pnd.eq.41) time_stamp='41'
        if(it_pnd.eq.42) time_stamp='42'
        if(it_pnd.eq.43) time_stamp='43'
        if(it_pnd.eq.44) time_stamp='44'
        if(it_pnd.eq.45) time_stamp='45'
        if(it_pnd.eq.46) time_stamp='46'
        if(it_pnd.eq.47) time_stamp='47'
        if(it_pnd.eq.48) time_stamp='48'
        if(it_pnd.eq.49) time_stamp='49'
        if(it_pnd.eq.50) time_stamp='50'
        if(it_pnd.ge.51) then
           write(*,*) 'output file name overflow : at pnd.F '
           write(*,*) 'please change your itoutX parameters '
           stop
        endif

      return
      end
c=======================================================================
c=======================================================================
c=======================================================================
c write pnds to files in Mathematica format
      subroutine output_pnd_math(x,y,pnd1x,pnd1y,pnd2x,pnd2y,
     &                               pnd3x,pnd3y,pnd4x,pnd4y,yaji,tinyR)

      implicit NONE

      CCTK_REAL x,y,yaji,pnd1,pnd2,pnd3,pnd4
      CCTK_REAL pnd1X,pnd1Y,pnd2X,pnd2Y,pnd3X,pnd3Y,pnd4X,pnd4Y
      CCTK_REAL pnd1XX,pnd1YY,pnd2XX,pnd2YY,pnd3XX,pnd3YY,pnd4XX,pnd4YY,tinyR
      
         pnd1=sqrt(pnd1X**2+pnd1Y**2+1.0e-15)
         pnd2=sqrt(pnd2X**2+pnd2Y**2+1.0e-15)
         pnd3=sqrt(pnd3X**2+pnd3Y**2+1.0e-15)
         pnd4=sqrt(pnd4X**2+pnd4Y**2+1.0e-15)
c      write(*,'(4e12.3)') pnd1,pnd2,pnd3,pnd4
      if(pnd1.lt.tinyR) then
         pnd1xx=0.0
         pnd1yy=0.0
      else
         pnd1xx=yaji*(pnd1X/pnd1)
         pnd1yy=yaji*(pnd1Y/pnd1)
      endif
      if(pnd2.lt.tinyR) then  
         pnd2xx=0.0
         pnd2yy=0.0
      else
         pnd2xx=yaji*(pnd2X/pnd2)
         pnd2yy=yaji*(pnd2Y/pnd2)
      endif
      if(pnd3.lt.tinyR) then
         pnd3xx=0.0
         pnd3yy=0.0
      else
         pnd3xx=yaji*(pnd3X/pnd3)
         pnd3yy=yaji*(pnd3Y/pnd3)
      endif
      if(pnd4.lt.tinyR) then
         pnd4xx=0.0
         pnd4yy=0.0
      else
         pnd4xx=yaji*(pnd4X/pnd4)
         pnd4yy=yaji*(pnd4Y/pnd4)
      endif

c     when you need {(x,y),(x+pndxx,y+pndyy)}
c$$$         WRITE(11,520) X,Y,X+pnd1XX,Y+pnd1YY
c$$$         WRITE(12,520) X,Y,X+pnd2XX,Y+pnd2YY
c$$$         WRITE(13,520) X,Y,X+pnd3XX,Y+pnd3YY
c$$$         WRITE(14,520) X,Y,X+pnd4XX,Y+pnd4YY
c     when you need {(x,y),(pndxx,pndyy)}
         WRITE(91,'(4e12.3)') X,Y,pnd1xx,pnd1yy
         WRITE(92,'(4e12.3)') X,Y,pnd2xx,pnd2yy
         WRITE(93,'(4e12.3)') X,Y,pnd3xx,pnd3yy
         WRITE(94,'(4e12.3)') X,Y,pnd4xx,pnd4yy
      
      return
      end

c#######################################################################
c input  ... check,tinycut
c output ... check
      subroutine check_tiny(check,tinycut)

      implicit none
      CCTK_REAL tinycut,check

      if(abs(check).lt.tinycut) check=0.0

      return
      end

c#######################################################################
c input  ... check,tinycut
c output ... check
      subroutine check_tinyc(check,tinycut)

      implicit none
      complex check
      CCTK_REAL    tinycut

      if(abs(check).lt.tinycut) then
        check=cmplx(0.0,0.0)
c        write(*,*) 'fixed'
      endif
      return
      end

c#######################################################################
