c=======================================================================
c file="pnd_output.f" 19980618 Hisaaki Shinkai shinkai@wurel.wustl.edu
c
c This file includes following subroutines:
c$$$      subroutine pnd2gridfunc(mjx,mjy,mjz,pnd1x,pnd1y,pnd1z,
c$$$     &                        pnvec1x,pnvec1y,pnvec1z)
c$$$      subroutine printpnd_in1(mpro,
c$$$     & x,y,z,ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
c$$$     &                        yaji,tiny,
c$$$     &                        pnvec1x,pnvec1y,pnvec1z,
c$$$     &                        pnvec2x,pnvec2y,pnvec2z,
c$$$     &                        pnvec3x,pnvec3y,pnvec3z,
c$$$     &                        pnvec4x,pnvec4y,pnvec4z)
c$$$      subroutine printpnd_in1_loop(
c$$$     &         ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
c$$$     &         x,y,pnvecX,pnvecY,yaji,tiny)
c$$$      subroutine printpnd_in1_loop3d(
c$$$     &         ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
c$$$     &         x,y,z,pnvecX,pnvecY,pnvecZ,yaji,tiny)
c=======================================================================
c########################################################### 19980618 ##
c#######################################################################
c input  ... pnd1x,pnd1y,pnd1z
c output ... pnvec1x,pnvec1y,pnvec1z

#include "cctk.h"
#include "cctk_Arguments.h"

      subroutine printpnd_in1_cactus(CCTK_ARGUMENTS,mpro,mx,my,mz,
     & ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &                        yaji,tiny,
     &                        pnvec1x,pnvec1y,pnvec1z,
     &                        pnvec2x,pnvec2y,pnvec2z,
     &                        pnvec3x,pnvec3y,pnvec3z,
     &                        pnvec4x,pnvec4y,pnvec4z)
      implicit none
      DECLARE_CCTK_ARGUMENTS

      integer mx,my,mz
      CCTK_REAL      pnvec1x(mx,my,mz),pnvec1y(mx,my,mz),pnvec1z(mx,my,mz)
      CCTK_REAL      pnvec2x(mx,my,mz),pnvec2y(mx,my,mz),pnvec2z(mx,my,mz)
      CCTK_REAL      pnvec3x(mx,my,mz),pnvec3y(mx,my,mz),pnvec3z(mx,my,mz)
      CCTK_REAL      pnvec4x(mx,my,mz),pnvec4y(mx,my,mz),pnvec4z(mx,my,mz)
      CCTK_REAL      yaji,tiny
      integer ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep
      integer mpro
      integer nx,ny,nz

c     define nx,ny,nz from cctk_lsh(DIM)
      nx=cctk_lsh(1)
      ny=cctk_lsh(2)
      nz=cctk_lsh(3)


c      write(*,*) shape(pnvec1x),shape(x)

      write(99,*) '(* This output is for Mathematica *)'
      write(99,*) '(* You only need to type "<< filename" *)'
      write(99,*) '(*     Hisaaki Shinkai : shinkai@wurel.wustl.edu *)'
      write(99,*) '(*     19980618 version  *)'
c--------------------------------------------------------------- on XY      
      if(mpro.eq.1) then
      write(99,*) '<<Graphics`PlotField`'
c pnd1
      write(99,*) 't1=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,y,pnvec1X,pnvec1Y,yaji,tiny)
c pnd2
      write(99,*) 't2=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,y,pnvec2X,pnvec2Y,yaji,tiny)
c pnd3
      write(99,*) 't3=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,y,pnvec3X,pnvec3Y,yaji,tiny)
c pnd4
      write(99,*) 't4=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,y,pnvec4X,pnvec4Y,yaji,tiny)
c
      write(99,*) 'p1=ListPlotVectorField[t1,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y }];'

      write(99,*) 'p2=ListPlotVectorField[t2,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y }];'

      write(99,*) 'p3=ListPlotVectorField[t3,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y }];'

      write(99,*) 'p4=ListPlotVectorField[t4,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y }];'
c--------------------------------------------------------------- on XZ      
      elseif(mpro.eq.2) then
      write(99,*) '<<Graphics`PlotField`'
c pnd1
      write(99,*) 't1=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,z,pnvec1X,pnvec1Z,yaji,tiny)
c pnd2
      write(99,*) 't2=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,z,pnvec2X,pnvec2Z,yaji,tiny)
c pnd3
      write(99,*) 't3=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,z,pnvec3X,pnvec3Z,yaji,tiny)
c pnd4
      write(99,*) 't4=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      x,z,pnvec4X,pnvec4Z,yaji,tiny)
c
      write(99,*) 'p1=ListPlotVectorField[t1,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, z }];'

      write(99,*) 'p2=ListPlotVectorField[t2,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, z }];'

      write(99,*) 'p3=ListPlotVectorField[t3,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, z }];'

      write(99,*) 'p4=ListPlotVectorField[t4,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, z }];'
c--------------------------------------------------------------- on YZ      
      elseif(mpro.eq.3) then
      write(99,*) '<<Graphics`PlotField`'
c pnd1
      write(99,*) 't1=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      y,z,pnvec1Y,pnvec1Z,yaji,tiny)
c pnd2
      write(99,*) 't2=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      y,z,pnvec2Y,pnvec2Z,yaji,tiny)
c pnd3
      write(99,*) 't3=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      y,z,pnvec3Y,pnvec3Z,yaji,tiny)
c pnd4
      write(99,*) 't4=List['
      call  printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &      ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &      y,z,pnvec4Y,pnvec4Z,yaji,tiny)
c
      write(99,*) 'p1=ListPlotVectorField[t1,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { y, z }];'

      write(99,*) 'p2=ListPlotVectorField[t2,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { y, z }];'

      write(99,*) 'p3=ListPlotVectorField[t3,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { y, z }];'

      write(99,*) 'p4=ListPlotVectorField[t4,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { y, z }];'

c--------------------------------------------------------------- on XYZ      
      elseif(mpro.eq.4) then
        write(99,*) '<<Graphics`PlotField3D`'
        write(99,*) 't1=List['
        call printpnd_in1_loop3d(
     &      nx,ny,nz,mx,my,mz,
     &       ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &       x,y,z,pnvec1X,pnvec1Y,pnvec1Z,yaji,tiny)
        write(99,*) 't2=List['
        call printpnd_in1_loop3d(
     &      nx,ny,nz,mx,my,mz,
     &       ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &       x,y,z,pnvec2X,pnvec2Y,pnvec2Z,yaji,tiny)
        write(99,*) 't3=List['
        call printpnd_in1_loop3d(
     &      nx,ny,nz,mx,my,mz,
     &       ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &       x,y,z,pnvec3X,pnvec3Y,pnvec3Z,yaji,tiny)
        write(99,*) 't4=List['
        call printpnd_in1_loop3d(
     &      nx,ny,nz,mx,my,mz,
     &       ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &       x,y,z,pnvec4X,pnvec4Y,pnvec4Z,yaji,tiny)
      write(99,*) 'p1=ListPlotVectorField3D[t1,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y, z }];'

      write(99,*) 'p2=ListPlotVectorField3D[t2,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y, z }];'

      write(99,*) 'p3=ListPlotVectorField3D[t3,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y, z }];'

      write(99,*) 'p4=ListPlotVectorField3D[t4,Axes -> True,'
      write(99,*) 'AxesStyle -> Automatic,AxesLabel -> { x, y, z }];'


      endif
      write(99,*) 'p5=Show[p1,p2,p3,p4]'


      return
      end
c=======================================================================
c########################################################### 19980618 ##
#include "cctk.h"

      subroutine printpnd_in1_loop(
     &      nx,ny,nz,mx,my,mz,
     &         ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &         x,y,pnvecX,pnvecY,yaji,tiny)
      implicit none
      integer nx,ny,nz,mx,my,mz
c input output
      CCTK_REAL    tiny,yaji
      CCTK_REAL    pnvecX(mx,my,mz), pnvecY(mx,my,mz)
      CCTK_REAL    x(nx,ny,nz),y(nx,ny,nz)
      integer ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep
c locally defined
      integer jx,jy,jz,mjx,mjy,mjz
      CCTK_REAL    xcord,ycord,pnd1,pnd1xx,pnd1yy

      do jz=izfrom,izto,izstep
      do jy=iyfrom,iyto,iystep
      do jx=ixfrom,ixto,ixstep
          mjx=ixfrom+(jx-ixfrom)/ixstep
          mjy=iyfrom+(jy-iyfrom)/iystep
          mjz=izfrom+(jz-izfrom)/izstep

            xcord=real(x(jx,jy,jz))
            ycord=real(y(jx,jy,jz))

          pnd1=sqrt(pnvecX(mjx,mjy,mjz)**2+pnvecY(mjx,mjy,mjz)**2
     &              +1.0e-15)
          if(pnd1.lt.tiny) then
            pnd1xx=0.0
            pnd1yy=0.0
          else
            pnd1XX=yaji*(pnvecX(mjx,mjy,mjz)/pnd1)
            pnd1YY=yaji*(pnvecY(mjx,mjy,mjz)/pnd1)
          endif

         if(jx.eq.ixto.AND.jy.eq.iyto.AND.jz.eq.izto) then
         write(99,'("{{",f14.5,",",f14.5,"},{",f14.5,",",f14.5,"}}];")')
     &         xcord,ycord,pnd1xx,pnd1yy
         else
         write(99,'("{{",f14.5,",",f14.5,"},{",f14.5,",",f14.5,"}},")')
     &         xcord,ycord,pnd1xx,pnd1yy
         endif
      enddo
      enddo
      enddo
      return
      end
c########################################################### 19980618 ##
c=======================================================================
c########################################################### 19980618 ##
#include "cctk.h"

      subroutine printpnd_in1_loop3d(
     &      nx,ny,nz,mx,my,mz,
     &         ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep,
     &         x,y,z,pnvecX,pnvecY,pnvecZ,yaji,tiny)
      implicit none
      integer nx,ny,nz,mx,my,mz
c input output
      CCTK_REAL    tiny,yaji
      CCTK_REAL    pnvecX(mx,my,mz), pnvecY(mx,my,mz), pnvecZ(mx,my,mz)
      CCTK_REAL    x(nx,ny,nz),y(nx,ny,nz),z(nx,ny,nz)
      integer ixfrom,ixto,ixstep,iyfrom,iyto,iystep,izfrom,izto,izstep
      integer mpro
c locally defined
      integer jx,jy,jz,mjx,mjy,mjz
      CCTK_REAL    xcord,ycord,zcord,pnd1,pnd1xx,pnd1yy,pnd1zz

      do jz=izfrom,izto,izstep
      do jy=iyfrom,iyto,iystep
      do jx=ixfrom,ixto,ixstep
          mjx=ixfrom+(jx-ixfrom)/ixstep
          mjy=iyfrom+(jy-iyfrom)/iystep
          mjz=izfrom+(jz-izfrom)/izstep

            xcord=real(x(jx,jy,jz))
            ycord=real(y(jx,jy,jz))
            zcord=real(z(jx,jy,jz))

          pnd1=sqrt(pnvecX(mjx,mjy,mjz)**2+pnvecY(mjx,mjy,mjz)**2
     &              +pnvecZ(mjx,mjy,mjz)**2+1.0e-15)
          if(pnd1.lt.tiny) then
            pnd1xx=0.0
            pnd1yy=0.0
            pnd1zz=0.0
          else
            pnd1xx=yaji*(pnvecX(mjx,mjy,mjz)/pnd1)
            pnd1yy=yaji*(pnvecY(mjx,mjy,mjz)/pnd1)
            pnd1zz=yaji*(pnvecZ(mjx,mjy,mjz)/pnd1)
          endif

         if(jx.eq.ixto.AND.jy.eq.iyto.AND.jz.eq.izto) then
         write(99,'("{{",f14.5,",",f14.5,",",f14.5,"},{",f14.5,",",f14.5,",",f14.5,"}}];")')
     &         xcord,ycord,zcord,pnd1xx,pnd1yy,pnd1zz
         else
         write(99,'("{{",f14.5,",",f14.5,",",f14.5,"},{",f14.5,",",f14.5,",",f14.5,"}},")')
     &         xcord,ycord,zcord,pnd1xx,pnd1yy,pnd1zz
         endif
      enddo
      enddo
      enddo
      return
      end
c########################################################### 19980618 ##
