#include "cctk.h"

      module arrays

      implicit none

      CCTK_INT lgeos

      CCTK_REAL, dimension (:), allocatable :: geoflag
      CCTK_REAL, dimension (:), allocatable :: geotau,geodtau,geodttau
      CCTK_REAL, dimension (:), allocatable :: geoxn,geoyn,geozn
      CCTK_REAL, dimension (:), allocatable :: geodtxn,geodtyn,geodtzn
      CCTK_REAL, dimension (:), allocatable :: geopxn,geopyn,geopzn
      CCTK_REAL, dimension (:), allocatable :: geodtpxn,geodtpyn,geodtpzn

      CCTK_REAL, dimension (:), allocatable :: geote
      CCTK_REAL, dimension (:), allocatable :: geoxe,geoye,geoze
      CCTK_REAL, dimension (:), allocatable :: geopxe,geopye,geopze

      CCTK_REAL, dimension (:), allocatable :: geonumI_r,geonumI_i
      CCTK_REAL, dimension (:), allocatable :: geonumJ_r,geonumJ_i
      CCTK_REAL, dimension (:), allocatable :: geoexaI_r,geoexaI_i
      CCTK_REAL, dimension (:), allocatable :: geoexaJ_r,geoexaJ_i

      CCTK_REAL, dimension (:), allocatable :: geoxni,geoyni,geozni
      CCTK_REAL, dimension (:), allocatable :: test1_x,test1_y,test1_z
      CCTK_REAL, dimension (:), allocatable :: test2,test3,test4

c     The arrays introduced above are (without the prefix "geo"):
c
c     flag                It is 1 if the geodesics are still inside the
c                         grid and 0 if they have drifted outside the grid.
c
c     tau                 Proper time along geodesics.
c     dtau                Change in proper time in the last timestep.
c     dttau               Time derivative of proper time.
c
c     xn,yn,zn            Position of geodesics.
c
c     pxn,pyn,pzn         Covariant momentum of geodesics.
c
c     dtxn,dtyn,dtzy      Time derivatives of position geodesics.
c     dtpxn,dtpyn,dtpzn   Time derivatives of momentum geodesics.
c
c     te                  Coordinate time along geodesics on exact spacetime.
c
c     xe,ye,ze            Position of geodesics on exact spacetime.
c
c     pxe,pye,pze         Covariant momentum of geodesics on exact spacetime.
c
c     xni,yni,zni         Initial position of geodesics.
c
c     test1               Test for consistency between contravariant
c                         and covariant momentum.  The array test1
c                         should be 0 up to round off error.
c
c     test2               Test to see if geodesics are in fact timelike
c                         and are properly normalized.  The array test2
c                         should be 0 up to round off error.
c
c     test3               Only valid in model flatty.  Check if coordinate
c                         speed of geodesics points in radial direction.
c                         The array test3 should be small and converge to
c                         0 to high order.
c
c     test4               Only valid in model flatty.  Check if angular
c                         metric is equal to square of Minkowski radius.
c                         The array test4 should be small and converge to
c                         0 to second order.

      end module arrays
