#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cctk.h"
#include "cctk_Parameters.h"

#include "EllBase.h"

static const char *rcsid = "$Header: /cactusdevcvs/CactusElliptic/EllPETSc/src/Startup.c,v 1.11 2004/05/17 12:28:57 goodale Exp $";

CCTK_FILEVERSION(CactusElliptic_EllPETSc_Startup_c)

void petsc_confmetric(cGH *GH, int *MetricPsiI, int *FieldI, int *MI,
                      int *NI, int *AbsTol, int *RelTol);

void petsc_metric(cGH *GH, int *MetricI, int *FieldI, int *MI,
                  int *NI, int *AbsTol, int *RelTol);

void petsc_flat(cGH *GH, int *FieldIndex, int *MIndex, int *NIndex, 
                int *AbsTol, int *RelTol);

/* Registration of the petsc solvers with the Elliptic solver registry.
   This routine registers petsc_confmetric under the name "petsc" for 
   the class of elliptic equations "LinConfMetric" */
   
int EllPETSc_Register(cGH *GH) 
{
  DECLARE_CCTK_PARAMETERS 
  
  Ell_RegisterSolver(petsc_confmetric,"petsc","Ell_LinConfMetric");
  Ell_RegisterSolver(petsc_metric,"petsc","Ell_LinMetric");
  Ell_RegisterSolver(petsc_flat,"petsc","Ell_LinFlat");

  return 0;
}
