#! /bin/sh
# /*@@
#   @file      setup.sh
#   @date      Sat May 31 17:56:34 CEST 2003
#   @author    Jonathan Thornburg, borrowing ++heavily from
#              Thomas Radke's LAPACK setup.sh
#   @desc
#              Setup for compilation with the BLAS library system installation
#              See http://www.netlib.org/blas/ for more info on the BLAS.
#   @enddesc
#   @version   $Header: /cactusdevcvs/CactusExternal/BLAS/BLAS.sh,v 1.8 2005/10/26 14:03:52 swhite Exp $
# @@*/

# /*@@
#   @routine    CCTK_Search
#   @date       Wed Jul 21 11:16:35 1999
#   @author     Tom Goodale
#   @desc
#   Used to search for something in various directories
#   @enddesc
#@@*/
                                                                                                                                                                             
CCTK_Search()
{
  eval  $1=""
  if test $# -lt 4 ; then
    cctk_basedir=""
  else
    cctk_basedir="$4/"
  fi
  for cctk_place in $2
    do
#      echo $ac_n "  Looking in $cctk_place""...$ac_c" #1>&6
      if test -r "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
      if test -d "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
#      echo "$ac_t"" No" #1>&6
    done
                                                                                                                                                                             
  return
}


# Search for BLAS installation
if test -z "$BLAS_DIR"; then
  echo "BEGIN MESSAGE"
  echo 'BLAS selected but no BLAS_DIR set... Checking some places'
  echo "END MESSAGE"

  CCTK_Search BLAS_DIR '/usr/lib /usr/local/lib' libblas.a
  if test -z "$BLAS_DIR"; then
    CCTK_Search BLAS_DIR '/usr/lib /usr/local/lib' libblas.so
  fi
  if test -z "$BLAS_DIR"; then
    echo "BEGIN ERROR"
    echo 'Thorn BLAS requires an external installation of the BLAS library.  ' \
         'Please set BLAS_DIR to the directory of this installation or ' \
	 'remove BLAS from your configuration ThornList.'
    echo "END ERROR"
    exit 2
  fi
  echo "BEGIN MESSAGE"
  echo "Found a BLAS package in $BLAS_DIR"
  echo "END MESSAGE"
elif test "$BLAS_DIR" = 'none'; then
  # user doesn't want the library path added
  BLAS_DIR=''
fi

if test -z "$BLAS_LIBS"; then
  BLAS_LIBS='blas'
fi


# write the variables out to the header and makefiles

echo "LIBRARY $BLAS_LIBS $BLAS_EXTRA_LIBS m"
echo "LIBRARY_DIRECTORY $BLAS_DIR $BLAS_EXTRA_LIB_DIRS"
