#! /bin/sh
# /*@@
#   @file      setup.sh
#   @date      Wed 8 January 2003
#   @author    Thomas Radke
#   @desc
#              Setup for compilation with the lapack library system installation
#   @enddesc
# @@*/

# /*@@
#   @routine    CCTK_Search
#   @date       Wed Jul 21 11:16:35 1999
#   @author     Tom Goodale
#   @desc
#   Used to search for something in various directories
#   @enddesc
#@@*/
                                                                                                                                                                             
CCTK_Search()
{
  eval  $1=""
  if test $# -lt 4 ; then
    cctk_basedir=""
  else
    cctk_basedir="$4/"
  fi
  for cctk_place in $2
    do
#      echo $ac_n "  Looking in $cctk_place""...$ac_c" #1>&6
      if test -r "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
      if test -d "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
#      echo "$ac_t"" No" #1>&6
    done
                                                                                                                                                                             
  return
}

# Search for LAPACK installation
if test -z "$LAPACK_DIR"; then
  echo "BEGIN MESSAGE"
  echo 'LAPACK selected but no LAPACK_DIR set... Checking some places'
  echo "END MESSAGE"
  CCTK_Search LAPACK_DIR '/usr/lib /usr/local/lib' liblapack.a
  if test -z "$LAPACK_DIR"; then
    CCTK_Search LAPACK_DIR '/usr/lib /usr/local/lib' liblapack.so
  fi
  if test -z "$LAPACK_DIR"; then
    echo "BEGIN ERROR"
    echo 'Thorn LAPACK requires an external installation of the LAPACK ' \
         'library.  Please set LAPACK_DIR to the directory of this ' \
	 'installation or remove LAPACK from your configuration ThornList.'
    echo "END ERROR"
    exit 2
  fi
  echo "BEGIN MESSAGE" 
  echo "Found a LAPACK package in $LAPACK_DIR"
  echo "END MESSAGE"

elif test "$LAPACK_DIR" = 'none'; then
  # user doesn't want the library path added
  LAPACK_DIR=''
fi

# TO DO:
# We should not add "blas" directly; the location and name of the BLAS
# library should be configured by CactusExternal/BLAS.  But leave it
# for the moment until we know that this actually works.
if test -z "$LAPACK_LIBS"; then
  LAPACK_LIBS='lapack blas'
fi

# write the variables out to the header and makefiles

echo "LIBRARY $LAPACK_LIBS $LAPACK_EXTRA_LIBS m"
echo "LIBRARY_DIRECTORY $LAPACK_DIR $LAPACK_EXTRA_LIB_DIRS"

