#! /bin/sh
#/*@@
#  @file   setup.sh
#  @date   Wed 03 Mar 2004
#  @author Erik Schnetter
#  @desc
#          Setup for an external Lorene installation
#  @enddesc
# @@*/

# /*@@
#   @routine    CCTK_Search
#   @date       Wed Jul 21 11:16:35 1999
#   @author     Tom Goodale
#   @desc
#   Used to search for something in various directories
#   @enddesc
#@@*/
                                                                                                                                                                             
CCTK_Search()
{
  eval  $1=""
  if test $# -lt 4 ; then
    cctk_basedir=""
  else
    cctk_basedir="$4/"
  fi
  for cctk_place in $2
    do
#      echo $ac_n "  Looking in $cctk_place""...$ac_c" #1>&6
      if test -r "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
      if test -d "$cctk_basedir$cctk_place/$3" ; then
#        echo "$ac_t""... Found" #1>&6
        eval $1="$cctk_place"
        break
      fi
#      echo "$ac_t"" No" #1>&6
    done
                                                                                                                                                                             
  return
}


# Work out LORENE's installation directory
if [ -z "$LORENE_DIR" ]; then
  echo "BEGIN MESSAGE"
  echo 'LORENE selected but no LORENE_DIR set.  Checking some places...'
  echo "END MESSAGE"
  CCTK_Search LORENE_DIR "$HOME_LORENE $LORENE_HOME /usr/local/lorene /usr/local/Lorene /usr/local/packages/lorene /usr/local/apps/lorene /opt/lorene /opt/Lorene" Export/C++/Include/bin_bh.h
  if [ -z "$LORENE_DIR" ] ; then
     echo "BEGIN ERROR"
     echo 'Thorn LORENE requires an external installation of LORENE.  ' \
          'Please set LORENE_DIR to specify the main directory of this ' \
          'installation or remove LORENE from your ThornList.'
     echo "END ERROR"
     exit 2
  fi
  echo "BEGIN MESSAGE"
  echo "Found a LORENE package in $LORENE_DIR"
  echo "END MESSAGE"
else
  echo "BEGIN MESSAGE"
  echo "Using LORENE package in $LORENE_DIR"
  echo "END MESSAGE"
fi


# Set platform-specific libraries
if [ -z "$LORENE_LIBS" ]; then
  LORENE_LIBS='lorene_export lorene lorenef77'
else
  echo "BEGIN MESSAGE"
  echo "Using LORENE libraries '$LORENE_LIBS'"
  echo "END MESSAGE"
fi

# Set the LORENE libs, libdirs and includedirs
LORENE_LIB_DIRS='$(LORENE_DIR)/Lib $(LORENE_DIR)/Export/BinBH'
LORENE_INC_DIRS='$(LORENE_DIR)/Export/C++/Include'


# Write the data out to the header and make files.

echo 'LIBRARY $(LORENE_LIBS)'
echo 'LIBRARY_DIRECTORY $(LORENE_LIB_DIRS)'
echo 'INCLUDE_DIRECTORY $(LORENE_INC_DIRS)'

