#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"
#include "IO.h"
#include "c_interface.h"

extern "C" { int Panda_Create(int, char **, int, int); }
extern "C" { void Panda_Finalize(); }
extern "C" { void Panda_WriteAttribute(char *, char *, int, int, void *); }
extern "C" { void *Panda_ReadAttribute(char *, char *, int *, int *); }
extern "C" { void PandaTimestep(struct ArrayInfo *); }
extern "C" { char *PandaReadTimestep(struct ArrayInfo *); }

int main(int argc, char **argv)
{
  int my_rank, i, j, k;
  ArrayInfo ainfo;
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
//  Panda_Create(argc, argv, 2, 1);
  if (Panda_Create(argc, argv, 2, 0))  { MPI_Finalize();  return 1; } 

  // Timestep-write  
/*  int size[3] = {16, 4, 4};
  int mem_layout[3] = {2, 1, 1};
  Distribution mem_dist[3] = {BLOCK, BLOCK, BLOCK};
  int disk_layout[1] = {2};
  Distribution disk_dist[3] = {BLOCK, NONE, NONE};
  int *data = (int *)malloc(sizeof(int) * 128);
  ainfo.name_ = "./panda.out";
  ainfo.rank_ = 3;
  ainfo.size_ = size;
  ainfo.esize_ = INT32;
  ainfo.mem_rank_ = 3;
  ainfo.mem_layout_ = mem_layout;
  ainfo.mem_dist_ = mem_dist;
  ainfo.disk_rank_ = 1;
  ainfo.disk_layout_ = disk_layout;
  ainfo.disk_dist_ = disk_dist;
  ainfo.data_ = (char*)data;

  for (i=0; i<8; i++)
    for (j=0; j<4; j++) 
      for (k=0; k<4; k++) data[i*16+j*4+k] = i*16+j*4+k + my_rank;

  ainfo.stencil_width_ = 0;
  PandaTimestep(&ainfo); 
  Panda_WriteAttribute("./panda.out", "global_size", INT32, 3, size);

  printf("%d - ", my_rank);
  for (i=0; i<8; i++)
    for (j=0; j<4; j++) 
      for (k=0; k<4; k++) printf("%d ", data[i*16+j*4+k]);
  printf("\n"); fflush(stdout);
  free(data);        */

  // ReadTimeste-write  
  int mem_layout[3] = {2, 1, 1};;
  Distribution mem_dist[3] = {BLOCK, BLOCK, BLOCK};
  ainfo.name_ = "./panda.out";
  ainfo.rank_ = 3;
  ainfo.size_ = NULL;
  ainfo.esize_ = 0;
  ainfo.mem_rank_ = 3;
  ainfo.mem_layout_ = mem_layout;
  ainfo.mem_dist_ = mem_dist;
  ainfo.disk_rank_ = 0;
  ainfo.disk_layout_ = NULL;
  ainfo.disk_dist_ = NULL;
  ainfo.data_ = NULL;

  int *data = (int *)PandaReadTimestep(&ainfo); 

  printf("%d - ", my_rank);
  for (i=0; i<8; i++)
    for (j=0; j<4; j++) 
      for (k=0; k<4; k++) printf("%d ", data[i*16+j*4+k]);
  printf("\n"); fflush(stdout);
  free(data);     

  int type, count;
  int *data1 = (int *)Panda_ReadAttribute("./panda.out", "global_size", 
					 &type,  &count);
  printf("%d: data type %d, count %d, contents: ", my_rank, type, count);
  for (i=0; i<count; i++) printf("%d ", data1[i]);
  printf("\n"); 
  free(data1); 

  Panda_Finalize();
  MPI_Finalize();
}
