#include <math.h>

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

static const char *rcsid = "$Id: Complex.c,v 1.3 2005/01/31 13:58:42 schnetter Exp $";

CCTK_FILEVERSION(CactusTest_LocalReduce_ReductionNorm4_c);

int TestComplexPower(CCTK_ARGUMENTS)
{
  
  DECLARE_CCTK_ARGUMENTS;
  DECLARE_CCTK_PARAMETERS;

    
  (*cmplx_num).Re = real_value;
  (*cmplx_num).Im = imaginary_value;
  
  (*cmplx_tmp) = CCTK_CmplxPow(*cmplx_num,power_value);

  real_part[0]      = (*cmplx_tmp).Re;
  imaginary_part[0] = (*cmplx_tmp).Im; 

  /* Now reverse the operation and see if we get the right answer back */
  if (fabs(power_value) < 1e-15)
  {
    CCTK_WARN (1, "Power value is zero, back-check will not be performed\n");
    return (0);
  }
  else
  {
    (*cmplx_tmp) = CCTK_CmplxPow(*cmplx_tmp, 1.0/power_value);
 
    if (fabs((*cmplx_tmp).Re - (*cmplx_num).Re) <= 1e-15 && fabs((*cmplx_tmp).Im == (*cmplx_num).Im) <= 1e-15)
    {
      CCTK_Info ("TestComplex","CCTK_CmplxPow is successful");
      return (0);
    }
    else
    {
      CCTK_WARN (1, "CCTK_CmplxPow was not successful\n");
      return (-1);
    }
  }
}

