#include "cctk.h"
#include "cctk_Arguments.h"

      subroutine InitComplex3D(CCTK_ARGUMENTS)

      implicit none

      DECLARE_CCTK_ARGUMENTS

      integer nx,ny,nz
      integer i,j,k

      nx = CCTK_LSH(1)
      ny = CCTK_LSH(2)
      nz = CCTK_LSH(3)

      do k=1,nz
        do j=1,ny
          do i=1, nx

            comp3d_p(i,j,k) = CMPLX(  sqrt(
     &                      	    dble(cctk_lbnd(1)+i)**2+
     &                      	    dble(cctk_lbnd(2)+j)**2+
     &	                    	    dble(cctk_lbnd(3)+k)**2)
     &                            ,
     &                              dble(cctk_lbnd(1)+i)**2+
     &                              dble(cctk_lbnd(2)+j)**2+
     &	                    	    dble(cctk_lbnd(3)+k)**2
     &                            )

	    comp3d(i,j,k) = comp3d_p(i,j,k)

          end do
        end do
      end do

      do k=1,10
         do j=1,10
            do i=1,10
               acomp3d(i,j,k) = dcmplx(i+j,j+k)
            end do
         end do
      end do

      do j=1,10
         do i=1,10
            acomp2d(i,j) = dcmplx(i,j)
         end do
      end do

      do i=1,10
         acomp1d(i) = dcmplx(1,i)
      end do

      scomp = dcmplx(1,2)

      end


      subroutine EvolveComplex3D(CCTK_ARGUMENTS)

      implicit none

      DECLARE_CCTK_ARGUMENTS

      integer nx,ny,nz
      integer i,j,k

      nx = CCTK_LSH(1)
      ny = CCTK_LSH(2)
      nz = CCTK_LSH(3)
	
      do k=2,nz-1
        do j=2,ny-1
          do i=2,nx-1

            comp3d(i,j,k) = 1.0/6.0*(
     &          comp3d_p(i-1,j,k)+comp3d_p(i+1,j,k)+
     &          comp3d_p(i,j-1,k)+comp3d_p(i,j+1,k)+
     &          comp3d_p(i,j,k-1)+comp3d_p(i,j,k+1)
     &      )

          end do
        end do
      end do

      end
