 /*@@
   @file      driver.F90
   @date      Thu Jan  9 15:24:32 2002
   @author    
   @desc 
   Routine driver for the reconstruction
   @enddesc 
 @@*/

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Parameters.h"


 /*@@
   @routine    driver.F90 
   @date       Thu Jan  9 15:24:32 2002
   @author     
   @desc 
   The driver for the reconstruction routine.
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/

subroutine Reconstruction(CCTK_ARGUMENTS)
  
  implicit none
  
  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS
  
  call tvdreconstruct(CCTK_PASS_FTOF, rho, rhoplus, rhominus)

  call tvdreconstruct(CCTK_PASS_FTOF, velx, velxplus, velxminus)
  call tvdreconstruct(CCTK_PASS_FTOF, vely, velyplus, velyminus)
  call tvdreconstruct(CCTK_PASS_FTOF, velz, velzplus, velzminus)
  call tvdreconstruct(CCTK_PASS_FTOF, press, pressplus, pressminus)
  
  call primitive2conservative(CCTK_PASS_FTOF)
  
  return
  
end subroutine Reconstruction
