 /*@@
   @file      DC_Setup.F90
   @date      Mon May 17 07:05:55 2004
   @author    Ian Hawke
   @desc 
   Initialize the local variables
   @enddesc 
 @@*/


#include "cctk.h"
#include "cctk_Parameters.h"
#include "cctk_Arguments.h"

 /*@@
   @routine    DC_Setup
   @date       Sun May 23 21:36:28 2004
   @author     Ian Hawke
   @desc 
   Initialize the drift correction variables
   @enddesc 
   @calls     
   @calledby   
   @history 
 
   @endhistory 

@@*/

subroutine DC_Setup(CCTK_ARGUMENTS)

  implicit none

  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS

  dc_iteration = 0
  dc_error = 0.d0
  dc_int_error = 0.d0
  dc_deriv_error = 0.d0
  
  dc_x = 1.d0
  dc_y = 0.d0
  dc_z = 0.d0

  dc_omega = 0.d0

end subroutine DC_Setup
