 /*@@
   @file       Whisky_Dust.F90
   @routine    Whisky_Dust_Analysis
   @date       Thu Aug  1 11:29:17 2002
   @author     Luca Baiotti
   @desc 
       Wrapper for calling the routines at analysis.
   @enddesc 
   @calls     Whisky_Dust_Set_Eta, Whisky_Dust
   @calledby   
   @history 
 
   @endhistory 
@@*/

#include "cctk.h"
#include "cctk_Arguments.h"
#include "cctk_Parameters.h"

#include "cctk_Functions.h"

subroutine Whisky_Dust_Analysis(CCTK_ARGUMENTS)

  implicit none

  DECLARE_CCTK_ARGUMENTS
  DECLARE_CCTK_PARAMETERS
  DECLARE_CCTK_FUNCTIONS

  CCTK_INT :: i
  character(len=100) :: infoline

  dust_analysis_flag = 1

  call Whisky_Dust_Set_Eta(CCTK_PASS_FTOF)

  if (CCTK_EQUALS(Dust_Gauge,"Maximal")) then
    
    dust_analysis_first_time = 1 ! for computing linearly eta(1) at the first step [Max Slicing]
  
  else if  (CCTK_EQUALS(Dust_Gauge,"Polar")) then
    
    dust_analysis_first_time = -1 ! these two lines together
    dust_analysis_evolve = 1      ! for computing eta(1) with analytic expr (root finding) [Polar] 
  
  else 
    
    write(infoline,'(a34)') "Dust_Gauge has a not allowed value in Whisky_Dust_Analysis"
    call CCTK_WARN(0,infoline)
  
  end if

  call Whisky_Dust(CCTK_PASS_FTOF)

end subroutine Whisky_Dust_Analysis
